import vault.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import java.io.*;

public class ProgramVault extends JFrame implements ActionListener
{
	JButton[] buttons;
	JLabel[] labels;
	String[] btnText,progDesc;
	String nextProg="",pwd=null;
	int i=0,count=0;
	ProgramVault(Container content, String runDir)
	{
		pwd=runDir;
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		try
		{
			BufferedReader bt=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/proglist"));
			BufferedReader cnt=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/proglist"));
			BufferedReader pd=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/progdesc"));
			while(cnt.readLine()!=null)
			{
				count++;
			}
			cnt.close();
			btnText=new String[count];
			progDesc=new String[count];
			buttons=new JButton[count];
			labels=new JLabel[count];
			while((nextProg=bt.readLine())!=null)
			{
				btnText[i]=nextProg;
				i++;
			}
			bt.close();
			i=0;
			while((nextProg=pd.readLine())!=null)
			{
				progDesc[i]=nextProg;
				i++;
			}
			pd.close();
		}
		catch(FileNotFoundException fnfe)
		{
			JOptionPane.showMessageDialog(this,"File proglist/progdesc not found");
		}
		catch(IOException ioe)
		{
			JOptionPane.showMessageDialog(this,"Error occured while reading file proglist/progdesc");
		}
		GridBagLayout gb=new GridBagLayout();
		GridBagConstraints gc=new GridBagConstraints();
		JPanel jp=new JPanel();
		jp.setLayout(gb);
		content.add(jp,BorderLayout.CENTER);
		content.add(new JScrollPane(jp));
		//JLabel l=new JLabel("<html><br><br></html>");
		JLabel l=new JLabel(new ImageIcon(System.getProperty("TXTPATH")+"/images/progvault1.gif"));
		l.setMaximumSize(new Dimension(100,100));
		gc.gridx=0;
		gc.gridy=0;
		gc.insets=new Insets(15,15,15,15);
		gb.setConstraints(l,gc);
		jp.add(l);
		Font f=new Font("Serif",Font.BOLD,20);
		JLabel t=new JLabel("PROGRAM VAULT");
		t.setFont(f);
		gc.gridx=1;
		gc.gridy=0;
		gb.setConstraints(t,gc);
		jp.add(t);
		for(i=0;i<count;i++)
		{
			buttons[i]=new JButton("");
			labels[i]=new JLabel("");
			buttons[i].setText(btnText[i]);
			labels[i].setText(progDesc[i]);
			buttons[i].addActionListener(this);
			buttons[i].setActionCommand(btnText[i]);
			buttons[i].setPreferredSize(new Dimension(100,30));
			//buttons[i].setBorder(BorderFactory.createEmptyBorder());
			gc.gridx=0;
			gc.gridy=i+1;
			gc.insets=new Insets(0,0,15,15);
			gc.anchor=GridBagConstraints.LINE_START;
			gb.setConstraints(buttons[i],gc);
			jp.add(buttons[i]);
			gc.gridx=1;
			gc.gridy=i+1;
			gc.insets=new Insets(0,0,15,15);
			gc.anchor=GridBagConstraints.LINE_START;
			gb.setConstraints(labels[i],gc);
			jp.add(labels[i]);
		}
	}
	public void actionPerformed(ActionEvent ae)
	{
		String clicked=ae.getActionCommand();	
		Populator p=new Populator(clicked,pwd);
		p.show();
	}
}
