import java.io.*;
import java.awt.*;
import java.util.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class guihelp extends JFrame implements ListSelectionListener
{
	JSplitPane splitPane;
	JScrollPane left,right;
	String[] commandNames={"General Information","AutoMACS","GUISim","GUINalyzer","Program Vault","Parameter Editor","Miscellaneous"};
	JList commList;
	JTextArea helpText=new JTextArea();
	JLabel helpTitle=new JLabel();
	Font f=new Font("serif",Font.BOLD,20);
	String commandName=null;
	Hashtable commDesc=new Hashtable();
	int i=1,cnt=0;
	public guihelp(Container content, Dimension frSize)
	{
		helpTitle.setFont(f);
		helpTitle.setText("Welcome to GUIMACS Command Help Portal");
		
		commList=new JList(commandNames);
		commList.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
		commList.setSelectedIndex(0);
		commList.addListSelectionListener(this);
		
		left=new JScrollPane(commList);
		right=new JScrollPane(helpText);
		try {
			BufferedReader br=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/guihelp"));
			helpText.read(br,null);
		}
		catch (FileNotFoundException fnfe) {
			JOptionPane.showMessageDialog(this,"The file named guihelp is not found in the lists directory of your GUIMACS distribution.\nIt might have been moved or deleted.","File Not Found",JOptionPane.ERROR_MESSAGE);
		}
		catch (IOException ioe) {
			JOptionPane.showMessageDialog(this,"There was an IO error while reading the help file.","IO Error",JOptionPane.ERROR_MESSAGE);
		}
		helpText.setEditable(false);
		helpText.setFont(new Font("monospaced",Font.PLAIN,14));
		
		splitPane=new JSplitPane(JSplitPane.HORIZONTAL_SPLIT,true,left,right);
		splitPane.setOneTouchExpandable(true);
		splitPane.setDividerLocation(150);
		
		Dimension minimumSize = new Dimension(100, 50);
		left.setMinimumSize(minimumSize);
		right.setMinimumSize(minimumSize);
		
		content.add(splitPane,BorderLayout.CENTER);

		commDesc.put("General Information","guihelp");
		commDesc.put("AutoMACS","automacs");
		commDesc.put("GUISim","guisim");
		commDesc.put("GUINalyzer","guinal");
		commDesc.put("Program Vault","pvault");
		commDesc.put("Parameter Editor","paramed");
		commDesc.put("Miscellaneous","misc");
	}
	public void valueChanged(ListSelectionEvent lse)
	{
		if(!lse.getValueIsAdjusting())
		{
			JList theList=(JList)lse.getSource();
			int index=theList.getSelectedIndex();
			try{
				BufferedReader br=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/"+commDesc.get(commandNames[index]).toString()));
				helpText.read(br,null);
				helpText.setFont(new Font("monospaced",Font.PLAIN,14));
				helpText.setMargin(new Insets(10,10,10,10));
			}
			catch(FileNotFoundException fnfe)
			{
				JOptionPane.showMessageDialog(this,fnfe,"File Not Found Exception",JOptionPane.ERROR_MESSAGE);
			}
			catch(IOException ioe)
			{
				JOptionPane.showMessageDialog(this,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
			}
		}
	}
}
