import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;

public class paramEditor extends JFrame implements ActionListener
{
	Font f=new Font("Serif",Font.BOLD,20);
	JLabel title=new JLabel("MD Parameter Editor");
	JLabel desc=new JLabel("<html>This program allows the user to create Molecular Dynamics Parameter (MDP) files from scratch.<br><br>The user is to choose the required parameters from the ones listed below and enter appropriate<br>values in the text boxes given next to each of them. This program does not check for consistency<br>of values entered in any of the fields below. It is the user's responsibility to enter values<br>relevant to parameters used.</html>");
	String titles[]=new String[]{"Preprocessing","Run Control","Langevin Dynamics","Energy Minimization" , "Shell Molecular Dynamics", "Output Control", "Neighbor Searching", "Electrostatics", "VdW", "Tables", "Ewald", "Temperature Coupling", "Pressure Coupling", "Simulated Annealing", "Velocity Generation", "Bonds", "Energy Group Exclusions", "NMR Refinement", "Free Energy Perturbation", "Non-Equilibrium MD", "Electric Fields", "Mixed Quantum/Classical Dynamics"};
	String ppLblTxt[],rcLblTxt[],rcTxtBox[],ldLblTxt[],emLblTxt[],smdLblTxt[],ocLblTxt[],nsLblTxt[],esLblTxt[], vdwLblTxt[], tLblTxt[], ewLblTxt[],tcLblTxt[],pcLblTxt[],saLblTxt[],vgLblTxt[],bLblTxt[], egeLblTxt[],nrLblTxt[],fepLblTxt[],nemLblTxt[],efLblTxt[],qcLblTxt[];
	String IntOptTxt[],CmodeTxt[],NsTypeTxt[],PbcTxt[],CTypeTxt[],VdwTypeTxt[],DispCorrTxt[],OptfftTxt[],TcouplTxt[],PcouplTxt[], PcouplTypeTxt[],AnnealingTxt[],GenVelTxt[],ConstraintsTxt[],ConstAlgoTxt[],UnconstStartTxt[],MorseTxt[],DisreTxt[],DisreWtTxt[],DisreMixedTxt[],OrireTxt[],FreeEnrTxt[],QMTxt[],QMSchemeTxt[],SHTxt[];
	GridBagLayout[] gridbags,leftbags,rightbags;
	GridBagConstraints[] gridconsts,leftconsts,rightconsts;
	JLabel[] ppLabels,rcLabels,ldLabels,emLabels,smdLabels,ocLabels,nsLabels,esLabels,vdwLabels, tLabels, ewLabels,tcLabels, pcLabels,saLabels,vgLabels,bLabels,egeLabels,nrLabels,fepLabels,nemLabels,efLabels,qcLabels;
	JTextField[] ppTextBoxes,rcTextBoxes,ldTextBoxes,emTextBoxes,smdTextBoxes,ocTextBoxes,nsTextBoxes,esTextBoxes, vdwTextBoxes, tTextBoxes,ewTextBoxes,tcTextBoxes,pcTextBoxes,saTextBoxes,vgTextBoxes,bTextBoxes,egeTextBoxes,nrTextBoxes,fepTextBoxes,nemTextBoxes,efTextBoxes,qcTextBoxes;
	JComboBox IntOpt,CmodeOpt,NsTypeOpt,PbcOpt,CtypeOpt,VdwTypeOpt,DispCorrOpt, OptfftOpt,TcouplOpt,PcouplOpt,PcouplTypeOpt, AnnealingOpt,GenVelOpt,ConstraintsOpt,ConstAlgoOpt,UnconstStartOpt,MorseOpt,DisreOpt,DisreWtOpt,DisreMixedOpt,OrireOpt,FreeEnrOpt,QMOpt,QMSchemeOpt,SHOpt;
	JPanel[] panels,in_panels,left_panels,right_panels;
	JScrollPane[] scrpanes;
	JButton save;
	JFileChooser savefile,openfile;
	int i=0,j=0,returnVal,n;
	File infile,outfile;
	String mdp,value,line,pemode;
	Hashtable mdphash=new Hashtable();
	paramEditor(Container content, Dimension frSize, String runDir, String pemode)
	{
		setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		this.pemode=pemode;

		if(pemode.equals("emdp"))
		{
			openfile=new JFileChooser();
			returnVal=openfile.showOpenDialog(this);
			if(returnVal==JFileChooser.APPROVE_OPTION)
			{
				infile=openfile.getSelectedFile();
				infile=new File(infile.toString());
				try{
					BufferedReader br=new BufferedReader(new FileReader(infile));
					while((line=br.readLine())!=null)
					{
						if(line.length()>24 && line.indexOf(";")!=0)
						{
							String[] fields=line.split("=");
							mdphash.put(fields[0].trim(),fields[1].trim());
						}
					}
				}
				catch(FileNotFoundException fnfe){}
				catch(IOException ioe){}
				//Iterator it=mdphash.keySet().iterator();
				//while(it.hasNext()){
				//	System.out.println(mdphash.get(it.next()));
				//}
			}
		}

		title.setFont(f);
	
		GridBagLayout gb=new GridBagLayout();
		GridBagConstraints gc=new GridBagConstraints();

		JPanel pane=new JPanel(gb);
		content.add(pane,BorderLayout.CENTER);
		content.add(new JScrollPane(pane));
		
		gridbags=new GridBagLayout[titles.length];
		gridconsts=new GridBagConstraints[titles.length];
		leftbags=new GridBagLayout[titles.length];
		leftconsts=new GridBagConstraints[titles.length];
		rightbags=new GridBagLayout[titles.length];
		rightconsts=new GridBagConstraints[titles.length];
		panels=new JPanel[titles.length];
		in_panels=new JPanel[titles.length];
		left_panels=new JPanel[titles.length];
		right_panels=new JPanel[titles.length];
		scrpanes=new JScrollPane[titles.length];

		gc.gridx=0;
		gc.gridy=0;
		gc.weightx=0.4;
		gc.weighty=0.4;
		gc.insets=new Insets(10,10,10,10);
		gb.setConstraints(title,gc);
		pane.add(title);

		gc.gridx=0;
		gc.gridy=1;
		gc.insets=new Insets(10,10,10,10);
		gb.setConstraints(desc,gc);
		pane.add(desc);

		for(i=0;i<titles.length;i++)
		{
			gridbags[i]=new GridBagLayout();
			gridconsts[i]=new GridBagConstraints();
			leftbags[i]=new GridBagLayout();
			leftconsts[i]=new GridBagConstraints();
			rightbags[i]=new GridBagLayout();
			rightconsts[i]=new GridBagConstraints();
			panels[i]=new JPanel();
			left_panels[i]=new JPanel(leftbags[i]);
			right_panels[i]=new JPanel(rightbags[i]);
			panels[i].setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder(titles[i]),BorderFactory.createEmptyBorder(5,5,5,5)));
			in_panels[i]=new JPanel();
			in_panels[i].setLayout(gridbags[i]);
			scrpanes[i]=new JScrollPane(in_panels[i]);
			scrpanes[i].setAutoscrolls(true);
			scrpanes[i].setPreferredSize(new Dimension(frSize.width-100,150));
			gc.gridx=0;
			gc.gridy=i+2;
			gc.anchor=GridBagConstraints.PAGE_START;
			gb.setConstraints(panels[i],gc);
			pane.add(panels[i]);
			panels[i].add(scrpanes[i],BorderLayout.CENTER);
		}

		JPanel btPane=new JPanel(new FlowLayout());
		save=new JButton("Save to File");
		btPane.add(save);
		save.addActionListener(this);
		save.setActionCommand("save");
		gc.gridx=0;
		gc.gridy=titles.length+2;
		gb.setConstraints(btPane,gc);
		pane.add(btPane);
		
		
		//Code for Preprocessing options

		ppLblTxt=new String[]{"title","cpp","include","define"};

		ppLabels=new JLabel[ppLblTxt.length];
		ppTextBoxes=new JTextField[ppLblTxt.length];

		for(int i=0;i<ppLblTxt.length;i++)
		{
			ppLabels[i]=new JLabel(ppLblTxt[i]);
			ppLabels[i].setPreferredSize(new Dimension(150,15));
			ppTextBoxes[i]=new JTextField(10);
			if(pemode.equals("emdp") && mdphash.containsKey(ppLblTxt[i]))
			{
				ppTextBoxes[i].setText(mdphash.get(ppLblTxt[i]).toString());
			}
		}

		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<ppLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ppLabels[i],leftconsts[j]);
			left_panels[j].add(ppLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ppTextBoxes[i],leftconsts[j]);
			left_panels[j].add(ppTextBoxes[i]);
		}

		j++;
		
		//Code for Run Control options

		rcLblTxt = new String[]{"integrator","tinit","dt","nsteps","init_step","comm_mode", "nstcomm"};
		rcTxtBox=new String[]{"0","0.001","0","0","1"};
		rcLabels=new JLabel[rcLblTxt.length];
		rcTextBoxes=new JTextField[rcLblTxt.length-2];
		for(int i=0;i<rcLabels.length;i++)
		{
			rcLabels[i]=new JLabel(rcLblTxt[i]);
			rcLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<rcTextBoxes.length;i++)
		{
			rcTextBoxes[i]=new JTextField(10);
			rcTextBoxes[i].setText(rcTxtBox[i]);
			//rcTextBoxes[i].setText(rcTxtBox[i]);
			if(pemode.equals("emdp") && mdphash.containsKey(rcLblTxt[i]))
			{
				rcTextBoxes[i].setText(mdphash.get(rcLblTxt[i]).toString());
			}
			
		}

		IntOptTxt=new String[]{"Choose One","md","sd","bd","steep","cg","l-bfgs","nm","tpi"};
		CmodeTxt=new String[]{"Choose One","Linear","Angular","No"};
		IntOpt=new JComboBox(IntOptTxt);
		CmodeOpt=new JComboBox(CmodeTxt);
				
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<rcLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(rcLabels[i],leftconsts[j]);
			left_panels[j].add(rcLabels[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(IntOpt,leftconsts[j]);
		left_panels[j].add(IntOpt);
		
		for(int i=0;i<rcTxtBox.length-1;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(rcTextBoxes[i],leftconsts[j]);
			left_panels[j].add(rcTextBoxes[i]);
		}
		
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=5;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(CmodeOpt,leftconsts[j]);
		left_panels[j].add(CmodeOpt);

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=6;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(rcTextBoxes[4],leftconsts[j]);
		left_panels[j].add(rcTextBoxes[4]);

		j++;
		
		//Code for Langevin Dynamics options
		
		ldLblTxt=new String[]{"bd_fric","ld_seed"};
		
		ldLabels=new JLabel[ldLblTxt.length];
		ldTextBoxes=new JTextField[ldLblTxt.length];
		
		for(int i=0;i<ldLblTxt.length;i++)
		{
			ldLabels[i]=new JLabel(ldLblTxt[i]);
			ldLabels[i].setPreferredSize(new Dimension(150,15));
			ldTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<ldLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ldLabels[i],leftconsts[j]);
			left_panels[j].add(ldLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ldTextBoxes[i],leftconsts[j]);
			left_panels[j].add(ldTextBoxes[i]);
		}

		j++;
		

		//Code for Energy Minimization options

		emLblTxt=new String[]{"emtol","emstep","nstcgsteep","nbfgscorr"};
		
		emLabels=new JLabel[emLblTxt.length];
		emTextBoxes=new JTextField[emLblTxt.length];
		
		for(int i=0;i<emLblTxt.length;i++)
		{
			emLabels[i]=new JLabel(emLblTxt[i]);
			emLabels[i].setPreferredSize(new Dimension(150,15));
			emTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<emLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(emLabels[i],leftconsts[j]);
			left_panels[j].add(emLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(emTextBoxes[i],leftconsts[j]);
			left_panels[j].add(emTextBoxes[i]);
		}

		j++;
		
		//Code for Shell Molecular Dynamics options

		smdLblTxt=new String[]{"emtol","niter","fcstep"};
		
		smdLabels=new JLabel[smdLblTxt.length];
		smdTextBoxes=new JTextField[smdLblTxt.length];
		
		for(int i=0;i<smdLblTxt.length;i++)
		{
			smdLabels[i]=new JLabel(smdLblTxt[i]);
			smdLabels[i].setPreferredSize(new Dimension(150,15));
			smdTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<smdLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(smdLabels[i],leftconsts[j]);
			left_panels[j].add(smdLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(smdTextBoxes[i],leftconsts[j]);
			left_panels[j].add(smdTextBoxes[i]);
		}

		j++;
		
		//Code for Output Control options

		ocLblTxt=new String[]{"nstxout","nstvout","nstfout","nstlog","nstenergy","nstxtcout","xtc_precision", "xtc_grps","energygrps"};
		
		ocLabels=new JLabel[ocLblTxt.length];
		ocTextBoxes=new JTextField[ocLblTxt.length];
		
		for(int i=0;i<ocLblTxt.length;i++)
		{
			ocLabels[i]=new JLabel(ocLblTxt[i]);
			ocLabels[i].setPreferredSize(new Dimension(150,15));
			ocTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<ocLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ocLabels[i],leftconsts[j]);
			left_panels[j].add(ocLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ocTextBoxes[i],leftconsts[j]);
			left_panels[j].add(ocTextBoxes[i]);
		}

		j++;
		
		//Code for Neighbor Searching options

		nsLblTxt=new String[]{"nstlist","ns_type","pbc","rlist"};
		
		nsLabels=new JLabel[nsLblTxt.length];
		nsTextBoxes=new JTextField[2];
		
		for(int i=0;i<nsLblTxt.length;i++)
		{
			nsLabels[i]=new JLabel(nsLblTxt[i]);
			nsLabels[i].setPreferredSize(new Dimension(150,15));
		}
		
		for(int i=0;i<nsTextBoxes.length;i++)
		{
			nsTextBoxes[i]=new JTextField(10);
		}

		NsTypeTxt=new String[]{"Choose One","grid","simple"};
		PbcTxt=new String[]{"Choose One","xyz","no"};
		NsTypeOpt=new JComboBox(NsTypeTxt);
		PbcOpt=new JComboBox(PbcTxt);
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<nsLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nsLabels[i],leftconsts[j]);
			left_panels[j].add(nsLabels[i]);
		}
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(nsTextBoxes[0],leftconsts[j]);
		left_panels[j].add(nsTextBoxes[0]);
			
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=1;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(NsTypeOpt,leftconsts[j]);
		left_panels[j].add(NsTypeOpt);
		
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=2;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(PbcOpt,leftconsts[j]);
		left_panels[j].add(PbcOpt);
		
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=3;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(nsTextBoxes[1],leftconsts[j]);
		left_panels[j].add(nsTextBoxes[1]);
		
		

		j++;
		
		//Code for Electrostatics options
		
		esLblTxt=new String[]{"coulomb_type","rcoulomb_switch","rcoulomb","epsilon_r","epsilon_rf"};
		CTypeTxt=new String[]{"Choose One","Cut-off","Ewald","PME","PPPM","Reaction-Field","Generalized-Reaction-Field","Reaction-Field-nec","Shift","Encad-Shift","Switch","User","PME-User"};
		
		esLabels=new JLabel[esLblTxt.length];
		esTextBoxes=new JTextField[esLblTxt.length-1];
		
		for(int i=0;i<esLblTxt.length;i++)
		{
			esLabels[i]=new JLabel(esLblTxt[i]);
			esLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<esTextBoxes.length;i++)
		{
			esTextBoxes[i]=new JTextField(10);
		}
		
		CtypeOpt=new JComboBox(CTypeTxt);
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<esLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(esLabels[i],leftconsts[j]);
			left_panels[j].add(esLabels[i]);
		}
	
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(CtypeOpt,leftconsts[j]);
		left_panels[j].add(CtypeOpt);

		for(int i=0;i<esTextBoxes.length;i++)
		{			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(esTextBoxes[i],leftconsts[j]);
			left_panels[j].add(esTextBoxes[i]);
		}

		j++;
		
		//Code for VdW Options
		
		vdwLblTxt=new String[]{"vdwtype","rvdw_switch","rvdw","DispCorr"};
		VdwTypeTxt=new String[]{"Choose One","Cut-off","Shift","Switch","Encad-Shift","User"};
		DispCorrTxt=new String[]{"Choose One","no","EnerPres","Ener"};
		
		vdwLabels=new JLabel[vdwLblTxt.length];
		vdwTextBoxes=new JTextField[vdwLblTxt.length-2];
		
		for(int i=0;i<vdwLblTxt.length;i++)
		{
			vdwLabels[i]=new JLabel(vdwLblTxt[i]);
			vdwLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<vdwTextBoxes.length;i++)
		{
			vdwTextBoxes[i]=new JTextField(10);
		}
		
		VdwTypeOpt=new JComboBox(VdwTypeTxt);
		DispCorrOpt=new JComboBox(DispCorrTxt);
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<vdwLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(vdwLabels[i],leftconsts[j]);
			left_panels[j].add(vdwLabels[i]);
		}
	
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(VdwTypeOpt,leftconsts[j]);
		left_panels[j].add(VdwTypeOpt);

		for(int i=0;i<vdwTextBoxes.length;i++)
		{			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(vdwTextBoxes[i],leftconsts[j]);
			left_panels[j].add(vdwTextBoxes[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=3;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(DispCorrOpt,leftconsts[j]);
		left_panels[j].add(DispCorrOpt);
		
		j++;
	
		//Code for Tables Options

		tLblTxt=new String[]{"table-extension","energygrp_table"};
		
		tLabels=new JLabel[tLblTxt.length];
		tTextBoxes=new JTextField[tLblTxt.length];
		
		for(int i=0;i<tLblTxt.length;i++)
		{
			tLabels[i]=new JLabel(tLblTxt[i]);
			tLabels[i].setPreferredSize(new Dimension(150,15));
			tTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<tLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(tLabels[i],leftconsts[j]);
			left_panels[j].add(tLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(tTextBoxes[i],leftconsts[j]);
			left_panels[j].add(tTextBoxes[i]);
		}

		j++;

		//Code for Ewald Options

		ewLblTxt=new String[]{"fourierspacing","fourier_nx","fourier_ny","fourier_nz","pme_order","ewald_rtol","ewald_geometry", "epsilon_surface","optimize_fft"};
		OptfftTxt=new String[]{"Choose One","no","yes"};
		
		ewLabels=new JLabel[ewLblTxt.length];
		ewTextBoxes=new JTextField[ewLblTxt.length-1];
		OptfftOpt=new JComboBox(OptfftTxt);
		
		for(int i=0;i<ewLblTxt.length;i++)
		{
			ewLabels[i]=new JLabel(ewLblTxt[i]);
			ewLabels[i].setPreferredSize(new Dimension(150,15));
		}

		for(int i=0;i<ewTextBoxes.length;i++)
		{
			ewTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<ewLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ewLabels[i],leftconsts[j]);
			left_panels[j].add(ewLabels[i]);
		}

		for(int i=0;i<ewTextBoxes.length;i++)
		{			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(ewTextBoxes[i],leftconsts[j]);
			left_panels[j].add(ewTextBoxes[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=8;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(OptfftOpt,leftconsts[j]);
		left_panels[j].add(OptfftOpt);

		j++;
		
		//Code for Temperature Coupling Options

		tcLblTxt=new String[]{"tcoupl","tc_grps","tau_t","ref_t"};
		TcouplTxt=new String[]{"Choose One","no","berendsen","nose-hoover"};
		
		tcLabels=new JLabel[tcLblTxt.length];
		tcTextBoxes=new JTextField[tcLblTxt.length-1];
		TcouplOpt=new JComboBox(TcouplTxt);
		
		for(int i=0;i<tcLblTxt.length;i++)
		{
			tcLabels[i]=new JLabel(tcLblTxt[i]);
			tcLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<tcTextBoxes.length;i++)
		{
			tcTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<tcLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(tcLabels[i],leftconsts[j]);
			left_panels[j].add(tcLabels[i]);
		}
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(TcouplOpt,leftconsts[j]);
		left_panels[j].add(TcouplOpt);

		for(int i=0;i<tcTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(tcTextBoxes[i],leftconsts[j]);
			left_panels[j].add(tcTextBoxes[i]);
		}

		j++;

		//Code for Pressure Coupling Options
		
		pcLblTxt=new String[]{"pcoupl","pcoupltype","tau_p","compressibility","ref_p"};
		PcouplTxt=new String[]{"Choose One","no","berendsen","Parrinello-Rahman"};
		PcouplTypeTxt=new String[]{"Choose One","isotropic","semiisotropic","anisotropic","surface-tension"};
		
		pcLabels=new JLabel[pcLblTxt.length];
		pcTextBoxes=new JTextField[pcLblTxt.length-2];
		PcouplOpt=new JComboBox(PcouplTxt);
		PcouplTypeOpt=new JComboBox(PcouplTypeTxt);
		
		for(int i=0;i<pcLblTxt.length;i++)
		{
			pcLabels[i]=new JLabel(pcLblTxt[i]);
			pcLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<pcTextBoxes.length;i++)
		{
			pcTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<pcLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(pcLabels[i],leftconsts[j]);
			left_panels[j].add(pcLabels[i]);
		}
		
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(PcouplOpt,leftconsts[j]);
		left_panels[j].add(PcouplOpt);

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=1;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(PcouplTypeOpt,leftconsts[j]);
		left_panels[j].add(PcouplTypeOpt);

		for(int i=0;i<tcTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+2;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(pcTextBoxes[i],leftconsts[j]);
			left_panels[j].add(pcTextBoxes[i]);
		}

		j++;

		//Code for Simulated Annealing Options

		saLblTxt=new String[]{"annealing","annealing_npoints","annealing_time","annealing_temp"};
		AnnealingTxt=new String[]{"Choose One","no","single","periodic"};
		
		saLabels=new JLabel[saLblTxt.length];
		saTextBoxes=new JTextField[saLblTxt.length-1];
		AnnealingOpt=new JComboBox(AnnealingTxt);
		
		for(int i=0;i<saLblTxt.length;i++)
		{
			saLabels[i]=new JLabel(saLblTxt[i]);
			saLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<saTextBoxes.length;i++)
		{
			saTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<saLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(saLabels[i],leftconsts[j]);
			left_panels[j].add(saLabels[i]);
		}
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(AnnealingOpt,leftconsts[j]);
		left_panels[j].add(AnnealingOpt);

		for(int i=0;i<saTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(saTextBoxes[i],leftconsts[j]);
			left_panels[j].add(saTextBoxes[i]);
		}

		j++;
		
		//Code for Velocity Generation Options

		vgLblTxt=new String[]{"gen_vel","gen_temp","gen_seed"};
		GenVelTxt=new String[]{"Choose One","no","yes"};
		
		vgLabels=new JLabel[vgLblTxt.length];
		vgTextBoxes=new JTextField[vgLblTxt.length-1];
		GenVelOpt=new JComboBox(GenVelTxt);
		
		for(int i=0;i<vgLblTxt.length;i++)
		{
			vgLabels[i]=new JLabel(vgLblTxt[i]);
			vgLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<vgTextBoxes.length;i++)
		{
			vgTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<vgLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(vgLabels[i],leftconsts[j]);
			left_panels[j].add(vgLabels[i]);
		}
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(GenVelOpt,leftconsts[j]);
		left_panels[j].add(GenVelOpt);

		for(int i=0;i<vgTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(vgTextBoxes[i],leftconsts[j]);
			left_panels[j].add(vgTextBoxes[i]);
		}

		j++;

		//Code for Bonds Options

		bLblTxt=new String[]{"constraints","constraint_algorithm","unconstrained_start","shake_tol", "lincs_order","lincs_iter","lincs_warnangle","morse"};
		ConstraintsTxt=new String[]{"Choose One","none","hbonds","all-bonds","h-angles","all-angles"};
		ConstAlgoTxt=new String[]{"Choose One","lincs","shake"};
		UnconstStartTxt=new String[]{"Choose One","no","yes"};
		MorseTxt=new String[]{"Choose One","no","yes"};
		
		bLabels=new JLabel[bLblTxt.length];
		bTextBoxes=new JTextField[bLblTxt.length-4];
		ConstraintsOpt=new JComboBox(ConstraintsTxt);
		ConstAlgoOpt=new JComboBox(ConstAlgoTxt);
		UnconstStartOpt=new JComboBox(UnconstStartTxt);
		MorseOpt=new JComboBox(MorseTxt);
		
		for(int i=0;i<bLblTxt.length;i++)
		{
			bLabels[i]=new JLabel(bLblTxt[i]);
			bLabels[i].setPreferredSize(new Dimension(150,15));
		}
		for(int i=0;i<bTextBoxes.length;i++)
		{
			bTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<bLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(bLabels[i],leftconsts[j]);
			left_panels[j].add(bLabels[i]);
		}
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(ConstraintsOpt,leftconsts[j]);
		left_panels[j].add(ConstraintsOpt);

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=1;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(ConstAlgoOpt,leftconsts[j]);
		left_panels[j].add(ConstAlgoOpt);

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=2;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(UnconstStartOpt,leftconsts[j]);
		left_panels[j].add(UnconstStartOpt);

		for(int i=0;i<bTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+3;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(bTextBoxes[i],leftconsts[j]);
			left_panels[j].add(bTextBoxes[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=7;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(MorseOpt,leftconsts[j]);
		left_panels[j].add(MorseOpt);

		j++;
		
		//Code for Energy Group Exclusions Options

		egeLblTxt=new String[]{"energygrp_excl"};
		
		egeLabels=new JLabel[egeLblTxt.length];
		egeTextBoxes=new JTextField[egeLblTxt.length];
		
		for(int i=0;i<egeLblTxt.length;i++)
		{
			egeLabels[i]=new JLabel(egeLblTxt[i]);
			egeLabels[i].setPreferredSize(new Dimension(150,15));
			egeTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<egeLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(egeLabels[i],leftconsts[j]);
			left_panels[j].add(egeLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(egeTextBoxes[i],leftconsts[j]);
			left_panels[j].add(egeTextBoxes[i]);
		}

		j++;
		
		//Code for NMR Refinement Options

		nrLblTxt=new String[]{"disre","disre_weighting","disre_mixed","disre_fc","disre_tau", "nstdisreout", "orire","orire_fc","orire_tau","orire_fitgrp","nstorireout"};
		DisreTxt=new String[]{"Choose One","no","simple","ensemble"};
		DisreWtTxt=new String[]{"Choose One","conservative","equal"};
		DisreMixedTxt=new String[]{"Choose One","no","yes"};
		OrireTxt=new String[]{"Choose One","no","yes"};
		
		nrLabels=new JLabel[nrLblTxt.length];
		nrTextBoxes=new JTextField[nrLblTxt.length-4];
		DisreOpt=new JComboBox(DisreTxt);
		DisreWtOpt=new JComboBox(DisreWtTxt);
		DisreMixedOpt=new JComboBox(DisreMixedTxt);
		OrireOpt=new JComboBox(OrireTxt);
		
		for(int i=0;i<nrLblTxt.length;i++)
		{
			nrLabels[i]=new JLabel(nrLblTxt[i]);
			nrLabels[i].setPreferredSize(new Dimension(150,15));
		}

		for(int i=0;i<nrTextBoxes.length;i++)
		{
			nrTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<nrLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nrLabels[i],leftconsts[j]);
			left_panels[j].add(nrLabels[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(DisreOpt,leftconsts[j]);
		left_panels[j].add(DisreOpt);
					
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=1;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(DisreWtOpt,leftconsts[j]);
		left_panels[j].add(DisreWtOpt);
					
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=2;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(DisreMixedOpt,leftconsts[j]);
		left_panels[j].add(DisreMixedOpt);

		for(int i=0;i<3;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+3;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nrTextBoxes[i],leftconsts[j]);
			left_panels[j].add(nrTextBoxes[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=6;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(OrireOpt,leftconsts[j]);
		left_panels[j].add(OrireOpt);
		
		for(int i=3;i<nrTextBoxes.length;i++)
		{
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+4;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nrTextBoxes[i],leftconsts[j]);
			left_panels[j].add(nrTextBoxes[i]);
			
		}
		
		j++;

		//Code for Free Energy Perturbation Options

		fepLblTxt=new String[]{"free_energy","init_lambda","delta_lambda","sc_alpha","sc_power","sc_sigma"};
		FreeEnrTxt=new String[]{"Choose One","no","yes"};
		
		fepLabels=new JLabel[fepLblTxt.length];
		fepTextBoxes=new JTextField[fepLblTxt.length-1];
		FreeEnrOpt=new JComboBox(FreeEnrTxt);
		
		for(int i=0;i<fepLblTxt.length;i++)
		{
			fepLabels[i]=new JLabel(fepLblTxt[i]);
			fepLabels[i].setPreferredSize(new Dimension(150,15));
		}

		for(int i=0;i<fepTextBoxes.length;i++)
		{
			fepTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<fepLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(fepLabels[i],leftconsts[j]);
			left_panels[j].add(fepLabels[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(FreeEnrOpt,leftconsts[j]);
		left_panels[j].add(FreeEnrOpt);

		for(int i=0;i<fepTextBoxes.length;i++)
		{			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+1;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(fepTextBoxes[i],leftconsts[j]);
			left_panels[j].add(fepTextBoxes[i]);
		}

		j++;

		//Code for Non-equilibrium MD Options

		nemLblTxt=new String[]{"acc_grps","accelerate","freezegrps","freezedim","cos_acceleration","deform"};
		
		nemLabels=new JLabel[nemLblTxt.length];
		nemTextBoxes=new JTextField[nemLblTxt.length];
		
		for(int i=0;i<nemLblTxt.length;i++)
		{
			nemLabels[i]=new JLabel(nemLblTxt[i]);
			nemLabels[i].setPreferredSize(new Dimension(150,15));
			nemTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<nemLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nemLabels[i],leftconsts[j]);
			left_panels[j].add(nemLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(nemTextBoxes[i],leftconsts[j]);
			left_panels[j].add(nemTextBoxes[i]);
		}

		j++;

		//Code for Electric Fields Options

		efLblTxt=new String[]{"E_x","E_y","E_z"};
		
		efLabels=new JLabel[efLblTxt.length];
		efTextBoxes=new JTextField[efLblTxt.length];
		
		for(int i=0;i<efLblTxt.length;i++)
		{
			efLabels[i]=new JLabel(efLblTxt[i]);
			efLabels[i].setPreferredSize(new Dimension(150,15));
			efTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<efLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(efLabels[i],leftconsts[j]);
			left_panels[j].add(efLabels[i]);
			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(efTextBoxes[i],leftconsts[j]);
			left_panels[j].add(efTextBoxes[i]);
		}

		j++;

		//Code for Mixed quantum/classical molecular dynamics Options

		qcLblTxt=new String[]{"QMMM","QMMM-grps","QMMMscheme","QMmethod","QMbasis","QMcharge","QMmult","CASorbitals","CASelectrons","SH"};
		QMTxt=new String[]{"Choose One","no","yes"};
		QMSchemeTxt=new String[]{"Choose One","normal","ONIOM","QMMM-grps"};
		SHTxt=new String[]{"Choose One","no","yes"};
		
		qcLabels=new JLabel[qcLblTxt.length];
		qcTextBoxes=new JTextField[qcLblTxt.length-3];
		QMOpt=new JComboBox(QMTxt);
		QMSchemeOpt=new JComboBox(QMSchemeTxt);
		SHOpt=new JComboBox(SHTxt);
		
		for(int i=0;i<qcLblTxt.length;i++)
		{
			qcLabels[i]=new JLabel(qcLblTxt[i]);
			qcLabels[i].setPreferredSize(new Dimension(150,15));
		}

		for(int i=0;i<qcTextBoxes.length;i++)
		{
			qcTextBoxes[i]=new JTextField(10);
		}
		
		gridconsts[j].gridx=0;
		gridconsts[j].gridy=0;
		gridconsts[j].weightx=0.4;
		gridconsts[j].weighty=0.4;
		gridconsts[j].ipadx=10;
		gridconsts[j].anchor=GridBagConstraints.LINE_START;
		gridbags[j].setConstraints(left_panels[j],gridconsts[j]);
		in_panels[j].add(left_panels[j]);
		
		for(int i=0;i<qcLabels.length;i++)
		{
			leftconsts[j].gridx=0;
			leftconsts[j].gridy=i;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(qcLabels[i],leftconsts[j]);
			left_panels[j].add(qcLabels[i]);
		}

		leftconsts[j].gridx=1;
		leftconsts[j].gridy=0;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(QMOpt,leftconsts[j]);
		left_panels[j].add(QMOpt);
			
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=1;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(qcTextBoxes[0],leftconsts[j]);
		left_panels[j].add(qcTextBoxes[0]);
			
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=2;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(QMSchemeOpt,leftconsts[j]);
		left_panels[j].add(QMSchemeOpt);

		for(int i=1;i<qcTextBoxes.length;i++)
		{			
			leftconsts[j].gridx=1;
			leftconsts[j].gridy=i+2;
			leftconsts[j].anchor=GridBagConstraints.LINE_START;
			leftconsts[j].insets=new Insets(5,5,5,5);
			leftbags[j].setConstraints(qcTextBoxes[i],leftconsts[j]);
			left_panels[j].add(qcTextBoxes[i]);
		}
		
		leftconsts[j].gridx=1;
		leftconsts[j].gridy=9;
		leftconsts[j].anchor=GridBagConstraints.LINE_START;
		leftconsts[j].insets=new Insets(5,5,5,5);
		leftbags[j].setConstraints(SHOpt,leftconsts[j]);
		left_panels[j].add(SHOpt);

	}	

	public void actionPerformed(ActionEvent ae)
	{
		if(ae.getActionCommand().equals("save"))
		{
			savefile=new JFileChooser();
			returnVal=savefile.showSaveDialog(this);
			if(returnVal==JFileChooser.APPROVE_OPTION)
			{
				outfile=savefile.getSelectedFile();
				if(outfile.exists())
				{
					n=JOptionPane.showConfirmDialog(null,"The file "+outfile.toString()+" already exists.\nDo you want to overwrite this file?","Confirm Overwrite",JOptionPane.YES_NO_OPTION);
				}
				else
				{
					outfile=new File(outfile.toString());
				}
				if(n==JOptionPane.YES_OPTION)
				{
					outfile=new File(outfile.toString());
				}
				try
				{
					BufferedWriter bw=new BufferedWriter(new FileWriter(outfile.toString()));

					bw.write(";\n;\tmdp input file\n;\tgenerated by GUIMACS\n;\n");
					//Read preprocessing parameters

					for(int i=0;i<ppTextBoxes.length;i++)
					{
						if(ppTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Preprocessing Parameters\n;\n");
							break;
						}
					}
										
					for(int i=0;i<ppTextBoxes.length;i++)
					{
						value=ppLabels[i].getText();
						value=prepareString(value);
						if(ppTextBoxes[i].getText().length()!=0)
						{
							bw.write(value+ppTextBoxes[i].getText()+"\n");
						}
					}

					//Read Run Control parameters
					
					for(int i=0;i<rcTextBoxes.length;i++)
					{
						if(rcTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Run Control Parameters\n;\n");
							break;
						}
					}
					
					if(IntOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(rcLabels[0].getText());
						bw.write(value+IntOpt.getSelectedItem().toString()+"\n");
					}
					for(int i=0;i<rcTextBoxes.length-1;i++)
					{
						value=prepareString(rcLabels[i+1].getText());
						bw.write(value+rcTextBoxes[i].getText()+"\n");
					}

					if(CmodeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(rcLabels[5].getText());
						bw.write(value+CmodeOpt.getSelectedItem().toString()+"\n");
					}
					if(rcTextBoxes[rcTextBoxes.length-1].getText().length()!=0)
					{
						value=prepareString(rcLabels[6].getText());
						bw.write(value+rcTextBoxes[rcTextBoxes.length-1].getText()+"\n");
					}
					
					//Read Langevin Dynamics parameters
					
					for(int i=0;i<ldTextBoxes.length;i++)
					{
						if(ldTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Langevin Dynamics Parameters\n;\n");
							break;
						}
					}

					for(int i=0;i<ldTextBoxes.length;i++)
					{
						if(ldTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(ldLabels[i].getText());
							bw.write(value+ldTextBoxes[i].getText()+"\n");
						}
					}

					//Read Energy Minimization parameters
					
					for(int i=0;i<emTextBoxes.length;i++)
					{
						if(emTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Energy Minimization Parameters\n;\n");
							break;
						}
					}

					for(int i=0;i<emTextBoxes.length;i++)
					{
						if(emTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(emLabels[i].getText());
							bw.write(value+emTextBoxes[i].getText()+"\n");
						}
					}

					//Read Shell Molecular Dynamics parameters
					
					for(int i=0;i<smdTextBoxes.length;i++)
					{
						if(smdTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Shell Molecular Dynamics Parameters\n;\n");
							break;
						}
					}

					for(int i=0;i<smdTextBoxes.length;i++)
					{
						if(smdTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(smdLabels[i].getText());
							bw.write(value+smdTextBoxes[i].getText()+"\n");
						}
					}

					//Read Output Control Parameters
					
					for(int i=0;i<ocTextBoxes.length;i++)
					{
						if(ocTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Output Control Parameters\n;\n");
							break;
						}
					}

					for(int i=0;i<ocTextBoxes.length;i++)
					{
						if(ocTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(ocLabels[i].getText());
							bw.write(value+ocTextBoxes[i].getText()+"\n");
						}
					}
				
					//Read Neighbor Searching Parameters
					
					for(int i=0;i<nsTextBoxes.length;i++)
					{
						if(nsTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Neighbor Searching Parameters\n;\n");
							break;
						}
					}

					if(nsTextBoxes[0].getText().length()!=0)
					{
						value=prepareString(nsLabels[0].getText());
						bw.write(value+nsTextBoxes[0].getText()+"\n");
					}

					if(NsTypeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nsLabels[1].getText());
						bw.write(value+NsTypeOpt.getSelectedItem().toString()+"\n");
					}

					if(PbcOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nsLabels[2].getText());
						bw.write(value+PbcOpt.getSelectedItem().toString()+"\n");
					}

					if(nsTextBoxes[1].getText().length()!=0)
					{
						value=prepareString(nsLabels[3].getText());
						bw.write(value+nsTextBoxes[1].getText()+"\n");
					}

					//Read Electrostatics Parameters

					for(int i=0;i<esTextBoxes.length;i++)
					{
						if(esTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Electrostatics Parameters\n;\n");
							break;
						}
					}

					if(CtypeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(esLabels[0].getText());
						bw.write(value+CtypeOpt.getSelectedItem().toString()+"\n");
					}
				
					for(int i=0;i<esTextBoxes.length;i++)
					{
						if(esTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(esLabels[i+1].getText());
							bw.write(value+esTextBoxes[i].getText()+"\n");
						}
					}

					//Read VdW Parameters

					for(int i=0;i<vdwTextBoxes.length;i++)
					{
						if(vdwTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; VdW Parameters\n;\n");
							break;
						}
					}

					if(VdwTypeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(vdwLabels[0].getText());
						bw.write(value+VdwTypeOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<vdwTextBoxes.length;i++)
					{
						if(vdwTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(vdwLabels[i+1].getText());
							bw.write(value+vdwTextBoxes[i].getText()+"\n");
						}
					}

					if(DispCorrOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(vdwLabels[3].getText());
						bw.write(value+DispCorrOpt.getSelectedItem().toString()+"\n");
					}

					//Read Tables Parameters

					for(int i=0;i<tTextBoxes.length;i++)
					{
						if(tTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Tables Parameters\n;\n");
							break;
						}
					}

					for(int i=0;i<tTextBoxes.length;i++)
					{
						if(tTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(tLabels[i].getText());
							bw.write(value+tTextBoxes[i].getText()+"\n");
						}
					}

					//Read Ewald Parameters

					for(int i=0;i<ewTextBoxes.length;i++)
					{
						if(ewTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Ewald Parameters\n;\n");
							break;
						}
					}
					
					for(int i=0;i<ewTextBoxes.length;i++)
					{
						if(ewTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(ewLabels[i].getText());
							bw.write(value+ewTextBoxes[i].getText()+"\n");
						}
					}
					
					if(OptfftOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(ewLabels[ewLabels.length-1].getText());
						bw.write(value+OptfftOpt.getSelectedItem().toString()+"\n");
					}

					//Read Temperature Coupling Parameters

					for(int i=0;i<tcTextBoxes.length;i++)
					{
						if(tcTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Temperature Coupling Parameters\n;\n");
							break;
						}
					}
					
					if(TcouplOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(tcLabels[0].getText());
						bw.write(value+TcouplOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<tcTextBoxes.length;i++)
					{
						if(tcTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(tcLabels[i+1].getText());
							bw.write(value+tcTextBoxes[i].getText()+"\n");
						}
					}

					//Read Pressure Coupling Parameters

					for(int i=0;i<pcTextBoxes.length;i++)
					{
						if(pcTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Pressure Coupling Parameters\n;\n");
							break;
						}
					}
					
					if(PcouplOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(pcLabels[0].getText());
						bw.write(value+PcouplOpt.getSelectedItem().toString()+"\n");
					}

					if(PcouplTypeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(pcLabels[1].getText());
						bw.write(value+PcouplTypeOpt.getSelectedItem().toString()+"\n");
					}
					
					for(int i=0;i<pcTextBoxes.length;i++)
					{
						if(pcTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(pcLabels[i+2].getText());
							bw.write(value+pcTextBoxes[i].getText()+"\n");
						}
					}

					//Read Simulated Annealing Parameters

					for(int i=0;i<saTextBoxes.length;i++)
					{
						if(saTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Simulated Annealing Parameters\n;\n");
							break;
						}
					}
					
					if(AnnealingOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(saLabels[0].getText());
						bw.write(value+AnnealingOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<saTextBoxes.length;i++)
					{
						if(saTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(saLabels[i+1].getText());
							bw.write(value+saTextBoxes[i].getText()+"\n");
						}
					}

					//Read Velocity Generation Parameters

					for(int i=0;i<vgTextBoxes.length;i++)
					{
						if(vgTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Velocity Generation Parameters\n;\n");
							break;
						}
					}

					if(GenVelOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(vgLabels[0].getText());
						bw.write(value+GenVelOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<vgTextBoxes.length;i++)
					{
						if(vgTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(vgLabels[i+1].getText());
							bw.write(value+vgTextBoxes[i].getText()+"\n");
						}
					}

					//Read Bonds Parameters

					for(int i=0;i<bTextBoxes.length;i++)
					{
						if(bTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Bonds Parameters\n;\n");
							break;
						}
					}

					if(ConstraintsOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(bLabels[0].getText());
						bw.write(value+ConstraintsOpt.getSelectedItem().toString()+"\n");
					}

					if(ConstAlgoOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(bLabels[1].getText());
						bw.write(value+ConstAlgoOpt.getSelectedItem().toString()+"\n");
					}

					if(UnconstStartOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(bLabels[2].getText());
						bw.write(value+UnconstStartOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<bTextBoxes.length;i++)
					{
						if(bTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(bLabels[i+3].getText());
							bw.write(value+bTextBoxes[i].getText()+"\n");
						}
					}

					if(MorseOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(bLabels[bLabels.length-1].getText());
						bw.write(value+MorseOpt.getSelectedItem().toString()+"\n");
					}

					//Read Energy Group Exclusions Parameters

					for(int i=0;i<egeTextBoxes.length;i++)
					{
						if(egeTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Energy Group Exclusions Parameters\n;\n");
							break;
						}
					}
										
					for(int i=0;i<egeTextBoxes.length;i++)
					{
						value=prepareString(egeLabels[i].getText());
						if(egeTextBoxes[i].getText().length()!=0)
						{
							bw.write(value+egeTextBoxes[i].getText()+"\n");
						}
					}

					//Read NMR Refinement Parameters

					for(int i=0;i<nrTextBoxes.length;i++)
					{
						if(nrTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; NMR Refinement Parameters\n;\n");
							break;
						}
					}

					if(DisreOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nrLabels[0].getText());
						bw.write(value+DisreOpt.getSelectedItem().toString()+"\n");
					}

					if(DisreWtOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nrLabels[1].getText());
						bw.write(value+DisreWtOpt.getSelectedItem().toString()+"\n");
					}

					if(DisreMixedOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nrLabels[2].getText());
						bw.write(value+DisreMixedOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<3;i++)
					{
						if(nrTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(nrLabels[i+3].getText());
							bw.write(value+nrTextBoxes[i].getText()+"\n");
						}
					}

					if(OrireOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(nrLabels[6].getText());
						bw.write(value+OrireOpt.getSelectedItem().toString()+"\n");
					}
					
					for(int i=3;i<nrTextBoxes.length;i++)
					{
						if(nrTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(nrLabels[i+4].getText());
							bw.write(value+nrTextBoxes[i].getText()+"\n");
						}
					}

					//Read Free Energy Perturbation Parameters

					for(int i=0;i<fepTextBoxes.length;i++)
					{
						if(fepTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Free Energy Perturbation Parameters\n;\n");
							break;
						}
					}

					if(FreeEnrOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(fepLabels[0].getText());
						bw.write(value+FreeEnrOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=0;i<fepTextBoxes.length;i++)
					{
						if(fepTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(fepLabels[i+1].getText());
							bw.write(value+fepTextBoxes[i].getText()+"\n");
						}
					}

					//Read Non-equilibrium MD Parameters

					for(int i=0;i<nemTextBoxes.length;i++)
					{
						if(nemTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Non-Equilibrium MD Parameters\n;\n");
							break;
						}
					}
										
					for(int i=0;i<nemTextBoxes.length;i++)
					{
						value=prepareString(nemLabels[i].getText());
						if(nemTextBoxes[i].getText().length()!=0)
						{
							bw.write(value+nemTextBoxes[i].getText()+"\n");
						}
					}

					//Read Electric Fields Parameters

					for(int i=0;i<efTextBoxes.length;i++)
					{
						if(efTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Electric Fields Parameters\n;\n");
							break;
						}
					}
										
					for(int i=0;i<efTextBoxes.length;i++)
					{
						if(efTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(efLabels[i].getText());
							bw.write(value+efTextBoxes[i].getText()+"\n");
						}
					}

					//Read Mixed Quantum/Classical Dynamics Parameters

					for(int i=0;i<qcTextBoxes.length;i++)
					{
						if(qcTextBoxes[i].getText().length()!=0)
						{
							bw.write(";\n; Mixed Quantum/Classical Dynamics Parameters\n;\n");
							break;
						}
					}

					if(QMOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(qcLabels[0].getText());
						bw.write(value+QMOpt.getSelectedItem().toString()+"\n");
					}

					if(qcTextBoxes[0].getText().length()!=0)
					{
						value=prepareString(qcLabels[1].getText());
						bw.write(value+qcTextBoxes[0].getText()+"\n");
					}

					if(QMSchemeOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(qcLabels[2].getText());
						bw.write(value+QMSchemeOpt.getSelectedItem().toString()+"\n");
					}

					for(int i=1;i<qcTextBoxes.length;i++)
					{
						if(qcTextBoxes[i].getText().length()!=0)
						{
							value=prepareString(qcLabels[i+2].getText());
							bw.write(value+qcTextBoxes[i].getText()+"\n");
						}
					}

					if(SHOpt.getSelectedItem().toString()!="Choose One")
					{
						value=prepareString(qcLabels[qcLabels.length-1].getText());
						bw.write(value+SHOpt.getSelectedItem().toString()+"\n");
					}

					bw.close();
				}
				catch(IOException ioe){}
			}
		}
	}

	public String prepareString(String value)
	{
		int len=value.length();
		for(int i=0;i<20-len;i++)
		{
			value+=" ";
		}
		value+="=  ";
		return value;
	}
		
}
