import java.io.*;
import java.util.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class setup extends JFrame implements ActionListener
{
	public static int NEW_PROFILE=0;
	public static int ALREADY_IN_PROFILE=1;
	public static int NOT_IN_PROFILE=2;
	JPanel topStaticPane,centerInfoPane,bottomStaticPane,pane;
	JButton bBack,bNext,bCancel,bGmxlib,bInstallPath;
	JLabel topPaneLabel,currentCompilation,gmxlibLabel,gmxlibInfo,installPathLabel,installInfo;
	final JProgressBar compileProgress=new JProgressBar();
	Font f;
	JTextField gmxlib,installPath;
	JRadioButton agree,disagree;
	ButtonGroup radioButtonGroup;
	int screenNumber=0,proceedStatus=1;
	float fileCount=0,progressValue=0;
	final String[] runcomm=new String[3];
	String nextLine=null,home=null,path=null;
	Properties envVars=new Properties();
	File inp;
	Vector profile=new Vector();
	JFileChooser jfc;
	setup()
	{
		super("GUIMACS Setup");

		runcomm[0]="/bin/bash";
		runcomm[1]="-c";
		
		Dimension scrSize=Toolkit.getDefaultToolkit().getScreenSize();
		Point p=new Point();
		p.x=(scrSize.width-640)/2;
		p.y=(scrSize.height-480)/2;
		if (p.x<0) {
			p.x=0;
		}
		if (p.y<0) {
			p.y=0;
		}
		this.setLocation(p);		
		pane=new JPanel();
		this.getContentPane().add(pane);
		pane.setLayout(new BoxLayout(pane,BoxLayout.PAGE_AXIS));
		
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		topStaticPane=new JPanel();
		f=new Font("serif",Font.BOLD,20);
		topPaneLabel=new JLabel("GUIMACS Setup",JLabel.LEFT);
		topPaneLabel.setPreferredSize(new Dimension(610,25));
		topStaticPane.add(topPaneLabel);
		topPaneLabel.setFont(f);
		topStaticPane.setPreferredSize(new Dimension(620,30));
		pane.add(topStaticPane);
		pane.add(Box.createRigidArea(new Dimension(0,10)));
		
		JSeparator topSep=new JSeparator();
		topSep.setPreferredSize(new Dimension(640,10));
		pane.add(topSep);

		centerInfoPane=new JPanel();
		centerInfoPane.setPreferredSize(new Dimension(620,350));
		pane.add(centerInfoPane);
		
		JSeparator endSep=new JSeparator();
		endSep.setPreferredSize(new Dimension(640,10));
		pane.add(endSep);
		
		bottomStaticPane=new JPanel();
		bottomStaticPane.setPreferredSize(new Dimension(620,30));
		pane.add(bottomStaticPane);
		pane.add(Box.createRigidArea(new Dimension(0,10)));

		bottomStaticPane.add(Box.createRigidArea(new Dimension(300,0)));

		bBack=new JButton("< Back");
		bBack.setMnemonic(KeyEvent.VK_B);
		bBack.addActionListener(this);
		bBack.setActionCommand("back");
		bottomStaticPane.add(bBack);
		
		bNext=new JButton("Next >");
		bNext.setMnemonic(KeyEvent.VK_N);
		bNext.addActionListener(this);
		bNext.setActionCommand("next");
		bottomStaticPane.add(bNext);
		
		bottomStaticPane.add(Box.createRigidArea(new Dimension(10,0)));
		
		bCancel=new JButton("Cancel");
		bCancel.setMnemonic(KeyEvent.VK_C);
		bCancel.addActionListener(this);
		bCancel.setActionCommand("cancel");
		bottomStaticPane.add(bCancel);

		initCenterPane(centerInfoPane);
	}
	public void initCenterPane(JPanel centerInfoPane) {
		bBack.setEnabled(false);
		bNext.setEnabled(true);
		topPaneLabel.setText("GUIMACS Setup");
		JLabel welcome=new JLabel("Welcome to GUIMACS setup");
		JPanel title=new JPanel();
		title.add(welcome);
		JLabel info=new JLabel("<html>The setup wizard takes you through a few simple steps<br>before you can use GUIMACS.<br><br>Click on 'Next' to continue</html>");
		JPanel text=new JPanel();
		text.add(info);
		Box main=Box.createVerticalBox();
		centerInfoPane.add(main);
		main.add(title);
		main.add(text);
		main.add(Box.createRigidArea(new Dimension(0,200)));
	}
	public void showTermsAndConditions(JPanel centerInfoPane) {
		topPaneLabel.setText("Terms and Conditions");
		bNext.setEnabled(false);
		bBack.setEnabled(true);
		centerInfoPane.setLayout(new BoxLayout(centerInfoPane,BoxLayout.PAGE_AXIS));
		
		JTextArea termsAndConditions=new JTextArea(10,5);
		termsAndConditions.setEditable(false);
		JPanel textAreaPane=new JPanel();
		textAreaPane.setPreferredSize(new Dimension(640,280));
		JScrollPane textAreaScrollPane=new JScrollPane(termsAndConditions);
		textAreaScrollPane.setPreferredSize(new Dimension(580,280));
		textAreaPane.add(Box.createRigidArea(new Dimension(10,0)));
		textAreaPane.add(textAreaScrollPane);
		try {
			BufferedReader br=new BufferedReader(new FileReader("lists/license"));
			termsAndConditions.read(br,null);
			termsAndConditions.setFont(new Font("monospaced",Font.PLAIN,12));
			termsAndConditions.setMargin(new Insets(10,10,10,10));
		}
		catch (FileNotFoundException fnfe) {System.out.println(fnfe);}
		catch (IOException ioe) {System.out.println(ioe);}
		
		JPanel radioButtons=new JPanel();
		radioButtons.setPreferredSize(new Dimension(600,20));
		
		agree=new JRadioButton("I Agree");
		agree.addActionListener(this);
		agree.setActionCommand("agree");
		disagree=new JRadioButton("I Disagree");
		disagree.addActionListener(this);
		disagree.setActionCommand("disagree");
		
		radioButtonGroup=new ButtonGroup();
		radioButtonGroup.add(agree);
		radioButtonGroup.add(disagree);

		radioButtons.add(agree);
		radioButtons.add(Box.createRigidArea(new Dimension(10,0)));
		radioButtons.add(disagree);

		centerInfoPane.add(Box.createRigidArea(new Dimension(0,10)));
		centerInfoPane.add(textAreaPane);
		centerInfoPane.add(radioButtons);
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,10)));
	
	}
	public void showCompileProgress(JPanel centerInfoPane) {
		centerInfoPane.setLayout(new BoxLayout(centerInfoPane,BoxLayout.PAGE_AXIS));
		topPaneLabel.setText("Compilation Progress");
		bBack.setEnabled(true);
		bNext.setEnabled(true);
		
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,20)));
		
		JPanel progressPane=new JPanel();
		progressPane.setPreferredSize(new Dimension(640,80));
		progressPane.add(Box.createRigidArea(new Dimension(5,0)));
		compileProgress.setMinimum(0);
		compileProgress.setMaximum(100);
		compileProgress.setValue(0);
		compileProgress.setStringPainted(true);
		compileProgress.setPreferredSize(new Dimension(580,20));
		progressPane.add(compileProgress);
		centerInfoPane.add(progressPane);
		
		JPanel compileStatus=new JPanel();
		compileStatus.setPreferredSize(new Dimension(640,80));
		compileStatus.add(Box.createRigidArea(new Dimension(15,0)));
		currentCompilation=new JLabel("Compiling simulator scripts...");
		currentCompilation.setPreferredSize(new Dimension(600,30));
		compileStatus.add(currentCompilation);
		centerInfoPane.add(compileStatus);

		centerInfoPane.add(Box.createRigidArea(new Dimension(0,260)));

		Thread runner=new Thread() {
			public void run() {
				try {
					bNext.setEnabled(false);
					bBack.setEnabled(false);
					
					BufferedReader sr=new BufferedReader(new FileReader("lists/compile"));
					fileCount=Integer.parseInt(sr.readLine());
					while((nextLine=sr.readLine())!=null) {
						if(nextLine.startsWith("simulator")) {
							currentCompilation.setText("Compiling simulator scripts...");
						}
						else if(nextLine.startsWith("analyzer")) {
							currentCompilation.setText("Compiling analyzer scripts...");
						}
						else if(nextLine.startsWith("vault")) {
							currentCompilation.setText("Compiling vault scripts...");
						}
						else {
							currentCompilation.setText("Compiling core scripts...");
						}
						runcomm[2]="javac -d . "+nextLine;
						Process compiler=Runtime.getRuntime().exec(runcomm);
						int ret=compiler.waitFor();
						if(ret==0) {
							progressValue=updateProgress(progressValue,fileCount);
						}
					}
					compileProgress.setValue(100);
					currentCompilation.setText("Compilation Done");
					bNext.setEnabled(true);
					bBack.setEnabled(true);
				}
				catch(InterruptedException inte){System.out.println(inte);}
				catch(IOException ioe){System.out.println(ioe);}
			}
			public float updateProgress(float startStep, float fileCount) {
				progressValue=startStep+(100/fileCount);
				compileProgress.setValue((int)progressValue);
				return progressValue;
			}
		};
		runner.start();
	}
	public void postCompilation(JPanel centerInfoPane) {
		bBack.setEnabled(true);
		bNext.setEnabled(true);
		centerInfoPane.setLayout(new BoxLayout(centerInfoPane,BoxLayout.PAGE_AXIS));
		topPaneLabel.setText("Finalizing installation");
		
		gmxlibLabel=new JLabel("Please enter a valid path for GROMACS 'top' directory");
		JPanel gmxlibLabelPane=new JPanel();
		gmxlibLabelPane.setPreferredSize(new Dimension(640,20));
		gmxlibLabelPane.add(gmxlibLabel);
		gmxlib=new JTextField(20);
		bGmxlib=new JButton("Browse");
		bGmxlib.addActionListener(this);
		bGmxlib.setActionCommand("gmxlib");
		JPanel gmxlibPane=new JPanel();
		gmxlibPane.setPreferredSize(new Dimension(640,30));
		gmxlibPane.add(gmxlib);
		gmxlibPane.add(Box.createRigidArea(new Dimension(10,0)));
		gmxlibPane.add(bGmxlib);
		JPanel gmxlibInfoPane=new JPanel();
		gmxlibInfo=new JLabel("<html>The environment variable GMXLIB points to the directory containing files pertaining to<br>force fields and GROMACS native files required for certain programs to run. Please make<br>sure you enter the correct path to the directory named 'top' that is provided along with the<br>GROMACS distribution.</html>");
		gmxlibInfoPane.add(gmxlibInfo);
		gmxlibInfoPane.setPreferredSize(new Dimension(640,80));
		
		installPathLabel=new JLabel("Please enter a valid path for installing GUIMACS");
		JPanel installPathLabelPane = new JPanel();
		installPathLabelPane.add(installPathLabel);
		installPath=new JTextField(20);
		bInstallPath=new JButton("Browse");
		bInstallPath.addActionListener(this);
		bInstallPath.setActionCommand("install");
		JPanel installPane=new JPanel();
		installPane.add(installPath);
		installPane.add(Box.createRigidArea(new Dimension(10,0)));
		installPane.add(bInstallPath);
		installInfo=new JLabel("<html>This is where the GUIMACS binary will be copied to.<br>It is recommended that you choose your own home directory for this purpose.</html>");
		JPanel installInfoPane=new JPanel();
		installInfoPane.add(installInfo);
		
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,10)));
		centerInfoPane.add(gmxlibLabelPane);
		centerInfoPane.add(gmxlibPane);
		centerInfoPane.add(gmxlibInfoPane);
		centerInfoPane.add(installPathLabelPane);
		centerInfoPane.add(installPane);
		centerInfoPane.add(installInfoPane);
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,10)));
		
	}
	public void finalizeInstallation() {
		if (gmxlib.getText().trim().length()==0) {
			JOptionPane.showMessageDialog(this,"Please enter a path for GMXLIB","Invalid Path",JOptionPane.ERROR_MESSAGE);
			gmxlib.requestFocus();
			proceedStatus=1;
		}
		else {
			proceedStatus=0;
			File inf=new File(gmxlib.getText().trim(),"/FF.dat");
			if(!inf.exists()) {
				JOptionPane.showMessageDialog(this,"The path you entered does not seem valid.\nPlease enter a valid path.","Invalid Path",JOptionPane.ERROR_MESSAGE);
				gmxlib.requestFocus();
				proceedStatus=1;
			}
			else {
				proceedStatus=0;
				if (installPath.getText().trim().length()==0) {
					JOptionPane.showMessageDialog(this,"Please enter a path to install GUIMACS","Invalide Path",JOptionPane.ERROR_MESSAGE);
					installPath.requestFocus();
					proceedStatus=1;
				}
				else {
					proceedStatus=0;
					inp=new File(installPath.getText().trim());
					if(!inp.canWrite()) {
						JOptionPane.showMessageDialog(this,"Cannot write to "+inp.toString()+"\nPlease choose an alternative path.","Insufficient File Permissions",JOptionPane.ERROR_MESSAGE);
						installPath.requestFocus();
						proceedStatus=1;
					}
					else {
						proceedStatus=0;
						try {
							Process env=Runtime.getRuntime().exec("/bin/bash -c env");
							BufferedReader br=new BufferedReader(new InputStreamReader(env.getInputStream()));
							while((nextLine=br.readLine())!=null) {
								String key=nextLine.substring(0,nextLine.indexOf("="));
								String value=nextLine.substring(nextLine.indexOf("=")+1);
								envVars.setProperty(key, value);
							}
							home=envVars.getProperty("HOME");
							path=envVars.getProperty("PATH");
							File bp=new File(home,"/.bash_profile");
							if(bp.exists()) {
								BufferedReader prof=new BufferedReader(new FileReader(home+"/.bash_profile"));
								while((nextLine=prof.readLine())!=null) {
									profile.addElement(nextLine);
								}
								if (profile.contains("#Added by GUIMACS")) {
									writeToProfile(ALREADY_IN_PROFILE);
								}
								else {
									writeToProfile(NOT_IN_PROFILE);
								}
							}
							else {
								writeToProfile(NEW_PROFILE);
							}
							JOptionPane.showMessageDialog(this,"Success !\nPress 'Next' to continue","Success",JOptionPane.INFORMATION_MESSAGE);
						}
						catch(IOException ioe){System.out.println(ioe);}
					}
				}
			}
		}
	}
	public void doneInstallation(JPanel centerInfoPane) {
		bNext.setText("Finish");
		bNext.setMnemonic(KeyEvent.VK_F);
		bNext.setEnabled(true);
		bBack.setEnabled(false);
		topPaneLabel.setText("Installation Successful");
		centerInfoPane.setLayout(new BoxLayout(centerInfoPane,BoxLayout.PAGE_AXIS));
		JLabel finalInfoTitle=new JLabel("Installation complete !");
		finalInfoTitle.setFont(new Font("serif",Font.BOLD,16));
		JLabel finalInfo=new JLabel("<html>You have successfully installed GUIMACS on your computer.<br>Before getting to use the program, you might have to issue the following command on the shell.<br><br>source ~/.bash_profile<br><br>However, this is not required for future invocations of GUIMACS.<br><br>Thank you for using GUIMACS.</html>");
		JPanel p1=new JPanel();
		JPanel p2=new JPanel();
		p1.add(finalInfoTitle);
		p2.add(finalInfo);
		p1.setPreferredSize(new Dimension(600,70));
		p2.setPreferredSize(new Dimension(600,170));
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,20)));
		centerInfoPane.add(p1);
		centerInfoPane.add(p2);
		centerInfoPane.add(Box.createRigidArea(new Dimension(0,130)));
	}
	public void actionPerformed(ActionEvent ae) {
		if (ae.getActionCommand().equals("next") && screenNumber==4) {
			System.exit(0);
		}
		if (ae.getActionCommand().equals("next") && screenNumber==3) {
			if(proceedStatus==0) {
				centerInfoPane.removeAll();
				doneInstallation(centerInfoPane);
				centerInfoPane.validate();
				centerInfoPane.repaint();
				screenNumber++;
			}
			else {
				finalizeInstallation();
			}
		}
		if (ae.getActionCommand().equals("next") && screenNumber==2) {
			centerInfoPane.removeAll();
			postCompilation(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber++;
		}			
		if (ae.getActionCommand().equals("next") && screenNumber==1) {
			centerInfoPane.removeAll();
			showCompileProgress(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber++;
		}			
		if (ae.getActionCommand().equals("next") && screenNumber==0) {
			centerInfoPane.removeAll();
			showTermsAndConditions(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber++;
		}
		if (ae.getActionCommand().equals("back") && screenNumber==1) {
			centerInfoPane.removeAll();
			initCenterPane(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber--;
		}
		if (ae.getActionCommand().equals("back") && screenNumber==2) {
			centerInfoPane.removeAll();
			showTermsAndConditions(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber--;
		}
		if (ae.getActionCommand().equals("back") && screenNumber==3) {
			centerInfoPane.removeAll();
			showTermsAndConditions(centerInfoPane);
			centerInfoPane.validate();
			centerInfoPane.repaint();
			screenNumber--;
		}
		if (ae.getActionCommand().equals("agree")) {
			bNext.setEnabled(true);
		}
		if (ae.getActionCommand().equals("disagree")) {
			bNext.setEnabled(false);
		}
		if (ae.getActionCommand().equals("cancel")) {
			int n=JOptionPane.showConfirmDialog(this,"Do you really want to quit installation?","Exit Setup",JOptionPane.YES_NO_OPTION);
			if (n==JOptionPane.YES_OPTION) {
				System.exit(0);
			}
		}
		if (ae.getActionCommand().equals("gmxlib") || ae.getActionCommand().equals("install")) {
			jfc=new JFileChooser();
			jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int retVal=jfc.showOpenDialog(this);
			if(retVal==JFileChooser.APPROVE_OPTION) {
				if (ae.getActionCommand().equals("gmxlib")) {
					gmxlib.setText(jfc.getSelectedFile().toString());
				}
				if (ae.getActionCommand().equals("install")) {
					installPath.setText(jfc.getSelectedFile().toString());
				}
			}
		}
	}
	public void writeToProfile(int profileStatus) {
		try {
			BufferedWriter bw=new BufferedWriter(new FileWriter(home+"/.bash_profile"));
			BufferedWriter gui=new BufferedWriter(new FileWriter("guimacs.sh"));
			gui.write("#!/bin/sh\n");
			gui.write("echo \"java -DTXTPATH=$PWD -DGMXLIB="+gmxlib.getText().trim()+" -classpath $PWD start\" > guimacs\n");
			gui.write("chmod +x guimacs\n");
			gui.write("cp guimacs "+inp.toString()+"\n");
			gui.close();
			if (profileStatus==NEW_PROFILE) {
				bw.write("#Added by GUIMACS\n");
				bw.write("PATH=$PATH:"+inp.toString()+"\n");
				bw.write("GMXLIB="+gmxlib.getText().trim()+"\n");
				bw.write("export PATH GMXLIB\n");
				bw.write("#Done");
				bw.close();
			}
			else if (profileStatus==ALREADY_IN_PROFILE) {
				if (profile.elementAt(profile.indexOf("#Added by GUIMACS")+1).toString().startsWith("PATH")) {
					profile.setElementAt("PATH=$PATH:"+inp.toString(),profile.indexOf("#Added by GUIMACS")+1);
				}
				else {
					profile.insertElementAt("PATH=$PATH:"+inp.toString(),profile.indexOf("#Added by GUIMACS")+1);
					profile.setElementAt("export PATH GMXLIB",profile.indexOf("#Added by GUIMACS")+3);
				}
				profile.setElementAt("GMXLIB="+gmxlib.getText().trim(),profile.indexOf("#Added by GUIMACS")+2);
				for(Enumeration e=profile.elements();e.hasMoreElements();) {
					String ne=e.nextElement().toString();
					bw.write(ne+"\n");
				}
				bw.close();
			}
			else if (profileStatus==NOT_IN_PROFILE) {
				profile.addElement("#Added by GUIMACS");
				profile.addElement("PATH=$PATH:"+inp.toString());
				profile.addElement("GMXLIB="+gmxlib.getText().trim());
				profile.addElement("export PATH GMXLIB");
				profile.addElement("#Done");
				for(Enumeration e=profile.elements();e.hasMoreElements();) {
					String ne=e.nextElement().toString();
					bw.write(ne+"\n");
				}
				bw.close();
			}
			else {
				for(Enumeration e=profile.elements();e.hasMoreElements();) {
					String ne=e.nextElement().toString();
					bw.write(ne+"\n");
				}
				bw.close();
			}
			String[] runcomm={"/bin/bash","-c","sh guimacs.sh"};
			Process inst=Runtime.getRuntime().exec(runcomm,null,(new File(System.getProperty("user.dir"))));
			inst.waitFor();

		}
		catch(IOException ioe){System.out.println(ioe);}
		catch(InterruptedException inte){System.out.println(inte);}
		
	}
	public static void createAndShowGUI() {
		setup s=new setup();
		s.setVisible(true);
		s.setSize(640,480);
		s.setResizable(false);
		s.setDefaultCloseOperation(EXIT_ON_CLOSE);
		JFrame.setDefaultLookAndFeelDecorated(true);
	}
	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				createAndShowGUI();
			}
		});
	}
}
