import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import java.io.*;
import java.util.*;
import java.lang.*;
public class start extends JFrame implements ActionListener
{
	JDialog jd;
	automacs am;
	guisim gs;
	guinalyzer gn;
	ProgramVault pv;
	paramEditor pe;
	guihelp gh;
	grohelp gr;
	JFrame f;
	String runDir=null,pwd=null,pemode="";
	int inset=50;
	JDesktopPane desktop;
	Dimension scrSize;
	String frTitle="GUIMACS";
	JTextField tProject;
	JTextArea jtaGetst;
	JMenuItem newProject,openProject,exitProject,automacs,guiSim,guiAna,prgvRun,pedtrSub1,pedtrSub2,commHelp,guiHelp,getstHelp,aboutHelp;
	JMenu pedtrRun;
	JButton bOpen;
	public start()
	{
		super("GUIMACS");
		pwd=System.getProperty("user.dir");
		runDir=pwd;
		bOpen=new JButton("Browse");
		bOpen.addActionListener(this);
		bOpen.setActionCommand("browse");
		//Place the frame in the centre of the screen
		scrSize=Toolkit.getDefaultToolkit().getScreenSize();
		setBounds(inset,inset,scrSize.width - inset*2,scrSize.height - inset*2);
		setJMenuBar(createMenuBar());
		desktop=new JDesktopPane();
		setContentPane(desktop);
		createFrame("Help","Getting Started");
		//System.out.println(System.getProperty("user.dir"));

	}
	protected void createFrame(String title,String runDir)
	{
		if(runDir.indexOf("/")==-1 && !title.equals("Help"))
		{
			runDir=pwd+"/"+runDir;
		}
		if(title.length()!=0)
		{
			if(title.equals("GUIMACS Command Help"))
			{
				frTitle="GUIMACS - Command Help";
			}
			else
			{
				frTitle+="-"+title+"-"+runDir;
			}
			JInternalFrame frame=new JInternalFrame(frTitle,true,true,true,true);
			frTitle="GUIMACS";
			frame.setVisible(true);
			frame.setBounds(inset,inset,scrSize.width-inset*4,scrSize.height-inset*4);
			desktop.add(frame);
			Dimension frSize=frame.getSize();
			Container content=frame.getContentPane();
			if(title.equals("AutoMACS"))
			{
				am=new automacs(content,runDir);
			}
			if(title.equals("Program Vault"))
			{
				pv=new ProgramVault(content,runDir);
			}
			if(title.equals("GUIMACS Simulator"))
			{
				gs=new guisim(content,frSize,runDir);
			}
			if(title.equals("GUIMACS Analyzer"))
			{
				gn=new guinalyzer(content,frSize,runDir);
			}
			if(title.equals("Parameter Editor"))
			{
				pe=new paramEditor(content,frSize,runDir,pemode);
			}
			if(title.equals("GROMACS Command Help"))
			{
				gr=new grohelp(content,frSize);
			}
			if(title.equals("GUIMACS Help")) {
				gh=new guihelp(content,frSize);
			}
			if(title.equals("Help"))
			{
				getStarted(content,frSize);
			}
			//setContentPane(frame);
			try
			{
				frame.setSelected(true);
			}
			catch(java.beans.PropertyVetoException pve){}
		}
	}
	protected JMenuBar createMenuBar()
	{
		JMenuBar menuBar=new JMenuBar();
		JMenu menuProject=new JMenu("Project");
		menuProject.setMnemonic(KeyEvent.VK_P);
		JMenu menuRun=new JMenu("Run");
		menuRun.setMnemonic(KeyEvent.VK_R);
		JMenu menuHelp=new JMenu("Help");
		menuHelp.setMnemonic(KeyEvent.VK_H);
		menuBar.add(menuProject);
		menuBar.add(menuRun);
		menuBar.add(menuHelp);
		
		newProject=new JMenuItem("New");
		newProject.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, ActionEvent.CTRL_MASK));
		newProject.setMnemonic(KeyEvent.VK_N);
		newProject.addActionListener(this);
		newProject.setActionCommand("new");
		
		openProject=new JMenuItem("Open");
		openProject.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_O, ActionEvent.CTRL_MASK));
		openProject.setMnemonic(KeyEvent.VK_O);
		openProject.addActionListener(this);
		openProject.setActionCommand("open");
		
		exitProject=new JMenuItem("Exit");
		exitProject.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_X, ActionEvent.ALT_MASK));
		exitProject.setMnemonic(KeyEvent.VK_X);
		exitProject.addActionListener(this);
		exitProject.setActionCommand("exit");

		automacs=new JMenuItem("AutoMACS");
		automacs.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_M, InputEvent.ALT_MASK));
		automacs.setMnemonic(KeyEvent.VK_M);
		automacs.addActionListener(this);
		automacs.setActionCommand("amacs");
	
		guiSim=new JMenuItem("GUISim");
		guiSim.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_S, ActionEvent.ALT_MASK));
		guiSim.setMnemonic(KeyEvent.VK_S);
		guiSim.addActionListener(this);
		guiSim.setActionCommand("gsim");

		guiAna=new JMenuItem("GUINalyzer");
		guiAna.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N,ActionEvent.ALT_MASK));
		guiAna.setMnemonic(KeyEvent.VK_N);
		guiAna.addActionListener(this);
		guiAna.setActionCommand("gana");
		
		prgvRun=new JMenuItem("Program Vault");
		prgvRun.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_V, ActionEvent.ALT_MASK));
		prgvRun.setMnemonic(KeyEvent.VK_V);
		prgvRun.addActionListener(this);
		prgvRun.setActionCommand("prgv");
		
		pedtrRun=new JMenu("Parameter Editor");
		pedtrRun.setMnemonic(KeyEvent.VK_P);

		pedtrSub1=new JMenuItem("Create New");
		pedtrSub1.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, InputEvent.ALT_MASK | InputEvent.SHIFT_MASK));
		pedtrSub1.setMnemonic(KeyEvent.VK_C);
		pedtrSub1.addActionListener(this);
		pedtrSub1.setActionCommand("omdp");
		
		pedtrSub2=new JMenuItem("Edit Existing");
		pedtrSub2.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_E, InputEvent.ALT_MASK | InputEvent.SHIFT_MASK));
		pedtrSub2.setMnemonic(KeyEvent.VK_E);
		pedtrSub2.addActionListener(this);
		pedtrSub2.setActionCommand("emdp");
		
		commHelp=new JMenuItem("GROMACS Command Help");
		commHelp.setMnemonic(KeyEvent.VK_H);
		commHelp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1, InputEvent.SHIFT_MASK));
		commHelp.addActionListener(this);
		commHelp.setActionCommand("comm");

		guiHelp=new JMenuItem("GUIMACS Help");
		guiHelp.setMnemonic(KeyEvent.VK_U);
		guiHelp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F1,0));
		guiHelp.addActionListener(this);
		guiHelp.setActionCommand("guihelp");
		
		getstHelp=new JMenuItem("Getting Started");
		getstHelp.setMnemonic(KeyEvent.VK_S);
		getstHelp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F8,0));
		getstHelp.addActionListener(this);
		getstHelp.setActionCommand("getst");

		aboutHelp = new JMenuItem("About GUIMACS");
		aboutHelp.setMnemonic(KeyEvent.VK_G);
		aboutHelp.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F3,0));
		aboutHelp.addActionListener(this);
		aboutHelp.setActionCommand("about");
		
		menuProject.add(newProject);
		menuProject.add(openProject);
		menuProject.addSeparator();
		menuProject.add(exitProject);
		
		menuRun.add(automacs);
		menuRun.add(guiSim);
		menuRun.add(guiAna);
		menuRun.add(prgvRun);
		menuRun.add(pedtrRun);
		pedtrRun.add(pedtrSub1);
		pedtrRun.add(pedtrSub2);
		
		menuHelp.add(guiHelp);
		menuHelp.add(commHelp);
		menuHelp.add(getstHelp);
		menuHelp.addSeparator();
		menuHelp.add(aboutHelp);
		
		automacs.setEnabled(false);
		guiSim.setEnabled(false);
		guiAna.setEnabled(false);

		return menuBar;
	}
	public void actionPerformed(ActionEvent ae)
	{
		String str=ae.getActionCommand();
		if(str.equals("new"))
		{
			f=new JFrame("New Project");
			f.setVisible(true);
			f.setSize(400,200);
			f.setResizable(false);
			f.setLocationRelativeTo(this);
			
			Box main=Box.createVerticalBox();
			Box tBox=Box.createHorizontalBox();
			Box mBox=Box.createHorizontalBox();
			Box lBox=Box.createHorizontalBox();
			Box dBox=Box.createHorizontalBox();
			main.add(Box.createRigidArea(new Dimension(0,20)));
			main.add(tBox);
			main.add(Box.createRigidArea(new Dimension(0,20)));
			main.add(mBox);
			main.add(Box.createRigidArea(new Dimension(0,15)));
			main.add(lBox);
			main.add(Box.createRigidArea(new Dimension(0,15)));
			main.add(dBox);
			main.add(Box.createRigidArea(new Dimension(0,30)));

			JLabel lImage=new JLabel(new ImageIcon("images/new_017.gif"));
			JLabel lText=new JLabel("Please fill in the following fields appropriately.");
			tBox.add(lImage);
			tBox.add(Box.createRigidArea(new Dimension(10,0)));
			tBox.add(lText);

			JLabel lTitle=new JLabel("Project Name: ");
			tProject=new JTextField(10);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));
			mBox.add(lTitle);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));
			mBox.add(tProject);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));

			JButton pok=new JButton("Done");
			pok.addActionListener(this);
			pok.setActionCommand("newproj");
			dBox.add(pok);
			
			f.getContentPane().add(main,BorderLayout.CENTER);
			f.show();
		}
		if(str.equals("open"))
		{
			f=new JFrame("Open Project");
			f.setVisible(true);
			f.setSize(400,200);
			f.setResizable(false);
			f.setLocationRelativeTo(this);
			
			Box main=Box.createVerticalBox();
			Box tBox=Box.createHorizontalBox();
			Box mBox=Box.createHorizontalBox();
			Box lBox=Box.createHorizontalBox();
			Box dBox=Box.createHorizontalBox();
			main.add(Box.createRigidArea(new Dimension(0,20)));
			main.add(tBox);
			main.add(Box.createRigidArea(new Dimension(0,20)));
			main.add(mBox);
			main.add(Box.createRigidArea(new Dimension(0,15)));
			main.add(lBox);
			main.add(Box.createRigidArea(new Dimension(0,15)));
			main.add(dBox);
			main.add(Box.createRigidArea(new Dimension(0,30)));

			JLabel lImage=new JLabel(new ImageIcon("images/new_017.gif"));
			JLabel lText=new JLabel("Please fill in the following fields appropriately.");
			tBox.add(lImage);
			tBox.add(Box.createRigidArea(new Dimension(10,0)));
			tBox.add(lText);

			JLabel lTitle=new JLabel("Project Name: ");
			tProject=new JTextField(10);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));
			mBox.add(lTitle);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));
			mBox.add(tProject);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));
			mBox.add(bOpen);
			mBox.add(Box.createRigidArea(new Dimension(10,0)));

			JButton pok=new JButton("Done");
			pok.addActionListener(this);
			pok.setActionCommand("openproj");
			dBox.add(pok);
			
			f.getContentPane().add(main,BorderLayout.CENTER);
			f.show();
		}
		if(str.equals("newproj"))
		{
			runDir=tProject.getText().trim();
			if(runDir.length()==0)
			{
				JOptionPane.showMessageDialog(this,"Please enter proper values for both the fields","Error",JOptionPane.ERROR_MESSAGE);
				if(runDir.length()==0)
				{
					tProject.requestFocus();
				}
			}
			else
			{
				boolean success=(new File(runDir)).mkdir();
				if(!success)
				{
					JOptionPane.showMessageDialog(this,"Directory creation failed.\nThis may be due to one of the several reasons.\n\n1. The directory already exists\n2. You don't have enough privileges to create new directories.\n3. You might have tried nested directory creation. (e.g. my/directory).\n4. Other system specific reasons.\n\nPlease correct the problem and try again.\nOr contact your system administrator for assistance.\n","Error",JOptionPane.ERROR_MESSAGE);
					tProject.requestFocus();
				}
				else
				{
					String disp=null;
					if(runDir.indexOf("/")==-1)
					{
						disp=pwd+"/"+runDir;
					}
					else
					{
						disp=runDir;
					}
					JOptionPane.showMessageDialog(this,"New project directory created successfully.\nYou may continue to run GROMACS scripts now.\nOutput files would be stored in the directory "+disp,"Success",JOptionPane.INFORMATION_MESSAGE);
					automacs.setEnabled(true);
					guiSim.setEnabled(true);
					guiAna.setEnabled(true);
					f.hide();
				}
			}	
		}
		if(str.equals("openproj"))
		{
			runDir=tProject.getText().trim();
			if(runDir.length()==0)
			{
				JOptionPane.showMessageDialog(this,"Please enter a valid name for the directory to open","Error",JOptionPane.ERROR_MESSAGE);
				if(runDir.length()==0)
				{
					tProject.requestFocus();
				}
			}
			else
			{
				boolean success=(new File(runDir)).isDirectory();
				if(!success || !(new File(runDir)).canWrite())
				{
                                       	JOptionPane.showMessageDialog(this,"Failed to open project.\nThis may be due to one of the several reasons.\n\n1. The directory does not exist (Hint: Use browse button)\n2. You don't have enough privileges to write to the directory.\n3. Other system specific reason.\n\nPlease correct the problem and try again.\nOr contact your system administrator for assistance.\n","Error",JOptionPane.ERROR_MESSAGE);
					tProject.requestFocus();
				}
				else
				{
					String disp=null;
					if(runDir.indexOf("/")==-1)
					{
						disp=pwd+"/"+runDir;
					}
					else
					{
						disp=runDir;
					}
					JOptionPane.showMessageDialog(this,"Project directory opened successfully.\nYou may continue to run GROMACS scripts now.\nOutput files would be stored in the directory "+disp,"Success",JOptionPane.INFORMATION_MESSAGE);
					automacs.setEnabled(true);
					guiSim.setEnabled(true);
					guiAna.setEnabled(true);
					f.hide();
				}
			}
		}
		if(str.equals("amacs"))
		{
			createFrame("AutoMACS",runDir);
		}
		if(str.equals("gsim"))
		{
			createFrame("GUIMACS Simulator",runDir);
		}
		if(str.equals("gana"))
		{
			createFrame("GUIMACS Analyzer",runDir);
		}
		if(str.equals("prgv"))
		{
			createFrame("Program Vault",runDir);	
		}
		if(str.equals("comm"))
		{
			createFrame("GROMACS Command Help","Contents");
		}
		if(str.equals("guihelp")) {
			createFrame("GUIMACS Help","Contents");
		}
		if(str.equals("getst"))
		{
			createFrame("Help","Getting Started");
		}
		if(str.equals("about"))
		{
			jd=new JDialog(this,"About GUIMACS",true);
			jd.setSize(500,400);
			jd.setLocationRelativeTo(this);
			jd.setResizable(false);
			Container fc=jd.getContentPane();
			String info="This program is distributed as freeware. This is provided \"as is\" without any guarantee made as to its suitability or fitness for any particular use. It may contain bugs, so use of this tool is at your own risk. Author takes no responsibility for any damage that may unintentionally be caused through its use. You may distribute GUIMACS in any form as long as it conforms to norms of the GNU-GPL.";
			JTextArea jta=new JTextArea(5,5);
			jta.setEditable(false);
			Box main=Box.createVerticalBox();
			fc.add(main);
			main.add(Box.createRigidArea(new Dimension(0,80)));
			Box tbox=Box.createHorizontalBox();
			JLabel lTitle=new JLabel("GUIMACS - 1.0");
			tbox.add(lTitle);
			lTitle.setFont(new Font("monospaced",Font.BOLD,40));
			main.add(tbox);
			main.add(Box.createRigidArea(new Dimension(0,20)));
			Box bbox=Box.createHorizontalBox();
			JLabel lBy=new JLabel("Coded by Pradeep Kota");
			bbox.add(lBy);
			main.add(bbox);
			main.add(Box.createRigidArea(new Dimension(0,80)));
			Box hbox=Box.createHorizontalBox();
			main.add(hbox);
			hbox.add(Box.createRigidArea(new Dimension(20,0)));
			jta.setText(info);
			jta.setLineWrap(true);
			jta.setWrapStyleWord(true);
			jta.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEtchedBorder(),BorderFactory.createEmptyBorder(10,10,10,10)));
			hbox.add(jta);
			hbox.add(Box.createRigidArea(new Dimension(20,0)));
			main.add(Box.createRigidArea(new Dimension(0,20)));
			jd.show();
		}
		if(str.equals("exit"))
		{
			System.exit(0);
		}
		if(str.indexOf("mdp")!=-1)
		{
			pemode=str;
			createFrame("Parameter Editor",runDir);
		}
		if(str.equals("browse")) {
			JFileChooser jfc=new JFileChooser();
			jfc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
			int ret=jfc.showOpenDialog(this);
			if(ret==JFileChooser.APPROVE_OPTION) {
				tProject.setText(jfc.getSelectedFile().toString());
			}
		}
	}
	public void getStarted(Container content, Dimension frSize)
	{
		Box main=Box.createHorizontalBox();
		content.add(main);
		
		jtaGetst = new JTextArea(5,10);
		jtaGetst.setMargin(new Insets(10,10,10,10));
		JScrollPane jsp=new JScrollPane(jtaGetst);
		main.add(jsp);
		jtaGetst.setEditable(false);
		jtaGetst.setFont(new Font("monospaced",Font.PLAIN,12));
		String nextLine="";
		try{
			BufferedReader br=new BufferedReader(new FileReader(System.getProperty("TXTPATH")+"/lists/getst"));
			while((nextLine=br.readLine())!=null){
				jtaGetst.setText(jtaGetst.getText()+nextLine+"\n");
			}
		}
		catch(FileNotFoundException fnfe){}
		catch(IOException ioe){}
		jtaGetst.setCaretPosition(0);
				
	}
	private static void createAndShowGUI() {
		start st=new start();
		st.setVisible(true);
		st.setExtendedState(JFrame.MAXIMIZED_BOTH);
		st.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
		JFrame.setDefaultLookAndFeelDecorated(true);
	}
	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new Runnable() {
			public void run() {
				createAndShowGUI();
			}
		});
	}
}
