package vault;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class g_energy implements ActionListener
{
	String title="g_energy";
	String help="<html>g_energy extracts energy components or distance restraint data from an energy<br>file. The user is prompted to interactively select the energy terms she<br>wants.<br><br>Average and RMSD are calculated with full precision from the simulation (see<br>printed manual). Drift is calculated by performing a LSQ fit of the data to a<br>straight line. Total drift is drift multiplied by total time.<br><br>When the -viol option is set, the time averaged violations are plotted and<br>the running time-averaged and instantaneous sum of violations are<br>recalculated. Additionally running time-averaged and instantaneous distances<br>between selected pairs can be plotted with the -pairs option.<br><br>Options -ora, -ort, -oda, -odr and -odt are used for analyzing orientation<br>restraint data. The first two options plot the orientation, the last three<br>the deviations of the orientations from the experimental values. The options<br>that end on an 'a' plot the average over time as a function of restraint. The<br>options that end on a 't' prompt the user for restraint label numbers and<br>plot the data as a function of time. Option -odr plots the RMS deviation as a<br>function of restraint. When the run used time or ensemble averaged<br>orientation restraints, option -orinst can be used to analyse the<br>instantaneous, not ensemble-averaged orientations and deviations instead of<br>the time and ensemble averages.<br><br>Option -oten plots the eigenvalues of the molecular order tensor for each<br>orientation restraint experiment. With option -ovec also the eigenvectors are<br>plotted.<br><br>With -fee an estimate is calculated for the free-energy difference with an<br>ideal gas state:<br>Delta A = A(N,V,T) - A_idgas(N,V,T) = kT ln < e^(Upot/kT) ><br>Delta G = G(N,p,T) - G_idgas(N,p,T) = kT ln < e^(Upot/kT) ><br>where k is Boltzmann's constant, T is set by -fetemp andthe average is over<br>the ensemble (or time in a trajectory). Note that this is in principle only<br>correct when averaging over the whole (Boltzmann) ensemble and using the<br>potential energy. This also allows for an entropy estimate using:<br>Delta S(N,V,T) = S(N,V,T) - S_idgas(N,V,T) = (<Upot> - Delta A)/T<br>Delta S(N,p,T) = S(N,p,T) - S_idgas(N,p,T) = (<Upot> + pV - Delta G)/T<br><br>When a second energy file is specified (-f2), a free energy difference is<br>calculated dF = -kT ln < e ^ -(EB-EA)/kT >A , where EA and EB are the<br>energies from the first and second energy files, and the average is over the<br>ensemble A. NOTE that the energies must both be calculated from the same<br>trajectory.</html>";
	String[] flags=new String[]{"-f","-f2","-s","-o","-viol","-pairs","-ora","-ort","-oda","-odt","-oten","-corr","-vis","-ravg"};
	String[] labelText=new String[]{"Input edr file","*Input edr file","*Input tpr file", "Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file"};
	String[] toolTips=new String[]{"Option: -f ; Filename: ener.edr ; Type: Input ; Description: Generic energy: edr ene","Option: -f2 ; Filename: ener.edr ; Type: Input, Opt. ; Description: Generic energy: edr ene","Option: -s ; Filename: topol.tpr ; Type: Input, Opt. ; Description: Generic run input: tpr tpb tpa xml","Option: -o ; Filename: energy.xvg ; Type: Output ; Description: xvgr/xmgr file","Option: -viol ; Filename: violaver.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -pairs ; Filename: pairs.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -ora ; Filename: orienta.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -ort ; Filename: orientt.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -oda ; Filename: orideva.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -odr ; Filename: oridevr.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -odt ; Filename: oridevt.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -oten ; Filename: oriten.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -corr ; Filename: enecorr.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -vis ; Filename: visco.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -ravg ; Filename: runavgdf.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file"};
	String[] optFlags=new String[]{"-[no]h","-[no]X","-nice","-[no]xvgr","-[no]free","-[no]rms","-cutoff"};
//	String[] optText=new String[]{"
	JLabel[] labels;
	JButton[] buttons;
	JPanel[] panels;
	JPanel[] reqPanes;
	JPanel[] optionPanes;
	JTextField[] textboxes;
	JCheckBox[] checkboxes;
	JFileChooser jfc=new JFileChooser();
	JTextField tbRun=new JTextField(70);
	JLabel helpLabel=new JLabel(help);
	JLabel titleLabel=new JLabel(title);
	InputStreamHandler ish=new InputStreamHandler();
	Font f=new Font("Serif",Font.BOLD,20);
	int x=0,y=1;
	public g_energy(Container content)
	{
		buttons=new JButton[flags.length];
		labels=new JLabel[flags.length];
		textboxes=new JTextField[flags.length];
		checkboxes=new JCheckBox[flags.length];
		panels=new JPanel[flags.length];
		optionPanes=new JPanel[flags.length];
		reqPanes=new JPanel[flags.length];
		
		GridBagLayout gb=new GridBagLayout();
		GridBagConstraints gc=new GridBagConstraints();
		JPanel pane=new JPanel(gb);
		content.add(pane,BorderLayout.CENTER);
		content.add(new JScrollPane(pane));
		titleLabel.setFont(f);
		gc.gridx=0;
		gc.gridy=0;
		gc.weightx=0.2;
		gc.weighty=0.3;
		gb.setConstraints(titleLabel,gc);
		pane.add(titleLabel);
		
		gc.gridx=0;
		gc.gridy=1;
		gb.setConstraints(helpLabel,gc);
		pane.add(helpLabel);
		
		GridBagLayout cgb=new GridBagLayout();
		GridBagConstraints cgc=new GridBagConstraints();
		JPanel centerPane=new JPanel(cgb);
		gc.gridx=0;
		gc.gridy=2;
		gb.setConstraints(centerPane,gc);
		pane.add(centerPane);
		
		GridBagLayout rgb=new GridBagLayout();
		GridBagConstraints rgc=new GridBagConstraints();
		JPanel reqPane=new JPanel(rgb);
		JScrollPane jsp=new JScrollPane(reqPane);
		jsp.setAutoscrolls(true);
		cgc.gridx=0;
		cgc.gridy=0;
		cgb.setConstraints(jsp,cgc);
		centerPane.add(jsp);
		centerPane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder("Required Parameters"),BorderFactory.createEmptyBorder(10,10,10,10)));
		
		JButton bOk=new JButton("OK");
		bOk.addActionListener(this);
		bOk.setActionCommand("ok");
		cgc.gridx=0;
		cgc.gridy=1;
		cgc.gridwidth=2;
		cgc.gridheight=2;
		cgc.anchor=GridBagConstraints.LINE_END;
		cgc.insets=new Insets(5,5,0,0);
		cgb.setConstraints(bOk,cgc);
		centerPane.add(bOk);
		
		for(int i=0;i<flags.length;i++)
		{
			if(i%2==0)
			{
				y++;
				x=0;
			}
			else
			{
				x=2;
			}				
			labels[i]=new JLabel(labelText[i]);
			panels[i]=new JPanel();
			reqPanes[i]=new JPanel();
			buttons[i]=new JButton("Browse");
			buttons[i].addActionListener(this);
			buttons[i].setActionCommand(flags[i]);
			checkboxes[i]=new JCheckBox(flags[i]);
			checkboxes[i].setToolTipText(toolTips[i]);
			textboxes[i]=new JTextField(10);
			panels[i].add(checkboxes[i]);
			panels[i].add(labels[i]);
			reqPanes[i].add(textboxes[i]);
			reqPanes[i].add(buttons[i]);
			rgc.gridx=x;
			rgc.gridy=y;
			rgc.anchor=GridBagConstraints.LINE_START;
			rgb.setConstraints(panels[i],rgc);
			reqPane.add(panels[i]);
			rgc.gridx=x+1;
			rgc.gridy=y;
			rgc.anchor=GridBagConstraints.LINE_START;
			rgb.setConstraints(reqPanes[i],rgc);
			reqPane.add(reqPanes[i]);
		}
		JPanel runPane=new JPanel(new FlowLayout());
		JButton bRun=new JButton("Run");
		tbRun.setText("g_energy ");
		bRun.addActionListener(this);
		bRun.setActionCommand("run");
		runPane.add(tbRun);
		runPane.add(bRun);
		gc.gridx=0;
		gc.gridy=3;
		gb.setConstraints(runPane,gc);
		pane.add(runPane);
	}
	public void actionPerformed(ActionEvent ae)
	{
		String btn=ae.getActionCommand();
		
		if(ae.getActionCommand().equals("ok"))
		{
			String command="g_energy ";
			for(int i=0;i<flags.length;i++)
			{
				if(checkboxes[i].isSelected())
				{
					command=command+flags[i]+" "+textboxes[i].getText()+" ";
				}
			}
			tbRun.setText(command);
		}
		if(ae.getActionCommand().equals("run"))
		{
			String comm=tbRun.getText();
			try
			{
				Process myProc=Runtime.getRuntime().exec(comm);
				InputStream iStream=myProc.getInputStream();
				InputStream eStream=myProc.getErrorStream();
				ish.handleStream(iStream,eStream);
				int evl=myProc.waitFor();
			}
			catch(IOException ioe)
			{
				System.out.println("IOException\n"+ioe);
			}
			catch(InterruptedException inte)
			{
				System.out.println("InterruptedException\n"+inte);
			}
		}
		for(int i=0;i<flags.length;i++)
		{
			if(btn.equals(flags[i]))
			{
				int retval=jfc.showOpenDialog(null);
				String fname="";
				if(retval==JFileChooser.APPROVE_OPTION)
				{
					File myFile=jfc.getSelectedFile();
					fname=myFile.toString();
					textboxes[i].setText(fname);
				}
			}
		}
	
	}
}
