package vault;
import java.io.*;
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;

public class g_rms implements ActionListener
{
	String title="g_rms";
	String command="g_rms ";
	String[] groups;
	GroupSelector gs;
	JWindow win;
	String help="<html>g_rms compares two structures by computing the root mean square deviation<br>(RMSD), the size-independent 'rho' similarity parameter (rho) or the scaled<br>rho (rhosc), see Maiorov & Crippen, PROTEINS 22, 273 (1995).<br><br>Refer to GUIMACS Help for a detailed description on g_rms.</html>";
	String[] flags=new String[]{"-s","-f","-f2","-n","-o","-mir","-a","-dist","-m","-bin","-bm"};
	String[] labelText=new String[]{"Input tpr file","Input xtc file","*Input xtc file","*Input ndx file","Output xvg file","*Output xvg file","*Output xvg file","*Output xvg file","*Output xpm file","*Output dat file","*Output xpm file"};
	String[] toolTips=new String[]{"Option: -s ; Filename: topol.tpr ; Type: Input ; Description: Structure+mass(db): tpr tpb tpa gro g96 pdb xml","Option: -f ; Filename: traj.xtc ; Type: Input ; Description: Generic trajectory: xtc trr trj gro g96 pdb","Option: -f2 ; Filename: traj.xtc ; Type: Input, Opt. ; Description: Generic trajectory: xtc trr trj gro g96 pdb","Option: -n ; Filename: index.ndx ; Type: Input, Opt. ; Description: Index file","Option: -o ; Filename: rmsd.xvg ; Type: Output ; Description: xvgr/xmgr file","Option: -mir ; Filename: rmsdmir.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -a ; Filename: avgrp.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -dist ; Filename: rmsd-dist.xvg ; Type: Output, Opt. ; Description: xvgr/xmgr file","Option: -m ; Filename: rmsd.xpm ; Type: Output, Opt. ; Description: X PixMap compatible matrix file","Option: -bin ; Filename: rmsd.dat ; Type: Output, Opt. ; Description: Generic data file","Option: -bm ; Filename: bond.xpm ; Type: Output, Opt. ; Description: X PixMap compatible matrix file"};
	String[] optFlags=new String[]{"-[no]h","-[no]X","-nice","-[no]xvgr","-[no]free","-[no]rms","-cutoff"};
//	String[] optText=new String[]{"
	output out;
	JLabel[] labels;
	JButton[] buttons;
	JPanel[] panels,reqPanes,optionPanes;
	JPanel pane;
	JTextField[] textboxes;
	JCheckBox[] checkboxes;
	JFileChooser jfc=new JFileChooser();
	JButton output=new JButton("View Output");
	JButton bLog,bErr,bClg,bCbk,bOut,bEnd;
	JTextArea tbRun=new JTextArea(5,60);
	JLabel helpLabel=new JLabel(help);
	JLabel titleLabel=new JLabel(title);
	Font f=new Font("Serif",Font.BOLD,20);
	JFrame opf;
	int x=0,y=1,cnt=0,ndx=0;
	String comm=null,pwd=null,nextline=null;
	public g_rms(Container content,String runDir)
	{
		pwd=runDir;
		jfc.setCurrentDirectory(new java.io.File(pwd));
		tbRun.setLineWrap(true);
		tbRun.setWrapStyleWord(true);
		buttons=new JButton[flags.length];
		labels=new JLabel[flags.length];
		textboxes=new JTextField[flags.length];
		checkboxes=new JCheckBox[flags.length];
		panels=new JPanel[flags.length];
		optionPanes=new JPanel[flags.length];
		reqPanes=new JPanel[flags.length];
		
		GridBagLayout gb=new GridBagLayout();
		GridBagConstraints gc=new GridBagConstraints();
		pane=new JPanel(gb);
		
		titleLabel.setFont(f);
		gc.gridx=0;
		gc.gridy=0;
		gc.weightx=0.2;
		gc.weighty=0.3;
		gb.setConstraints(titleLabel,gc);
		pane.add(titleLabel);
		
		gc.gridx=0;
		gc.gridy=1;
		gb.setConstraints(helpLabel,gc);
		pane.add(helpLabel);
		
		GridBagLayout cgb=new GridBagLayout();
		GridBagConstraints cgc=new GridBagConstraints();
		JPanel centerPane=new JPanel(cgb);
		gc.gridx=0;
		gc.gridy=2;
		gb.setConstraints(centerPane,gc);
		pane.add(centerPane);
		
		GridBagLayout rgb=new GridBagLayout();
		GridBagConstraints rgc=new GridBagConstraints();
		JPanel reqPane=new JPanel(rgb);
		JScrollPane jsp=new JScrollPane(reqPane);
		jsp.setAutoscrolls(true);
		cgc.gridx=0;
		cgc.gridy=0;
		cgb.setConstraints(jsp,cgc);
		centerPane.add(jsp);
		centerPane.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder("Required Parameters [ * denotes optional parameters ]"),BorderFactory.createEmptyBorder(10,10,10,10)));
		
		JButton bOk=new JButton("OK");
		bOk.addActionListener(this);
		bOk.setActionCommand("ok");
		cgc.gridx=0;
		cgc.gridy=1;
		cgc.gridwidth=2;
		cgc.gridheight=2;
		cgc.anchor=GridBagConstraints.LINE_END;
		cgc.insets=new Insets(5,5,0,0);
		cgb.setConstraints(bOk,cgc);
		centerPane.add(bOk);
		
		for(int i=0;i<flags.length;i++)
		{
			if(i%2==0)
			{
				y++;
				x=0;
			}
			else
			{
				x=2;
			}				
			labels[i]=new JLabel(labelText[i]);
			panels[i]=new JPanel();
			reqPanes[i]=new JPanel();
			buttons[i]=new JButton("Browse");
			buttons[i].addActionListener(this);
			buttons[i].setActionCommand(flags[i]);
			checkboxes[i]=new JCheckBox(flags[i]);
			checkboxes[i].setToolTipText(toolTips[i]);
			textboxes[i]=new JTextField(10);
			panels[i].add(checkboxes[i]);
			panels[i].add(labels[i]);
			reqPanes[i].add(textboxes[i]);
			reqPanes[i].add(buttons[i]);
			rgc.gridx=x;
			rgc.gridy=y;
			rgc.anchor=GridBagConstraints.LINE_START;
			rgb.setConstraints(panels[i],rgc);
			reqPane.add(panels[i]);
			rgc.gridx=x+1;
			rgc.gridy=y;
			rgc.anchor=GridBagConstraints.LINE_START;
			rgb.setConstraints(reqPanes[i],rgc);
			reqPane.add(reqPanes[i]);
		}
		JPanel runPane=new JPanel(new FlowLayout());
		JButton bRun=new JButton("Run");
		tbRun.setText("g_rms ");
		bRun.addActionListener(this);
		bRun.setActionCommand("run");
		JScrollPane runsp=new JScrollPane(tbRun,JScrollPane.VERTICAL_SCROLLBAR_ALWAYS,JScrollPane.HORIZONTAL_SCROLLBAR_AS_NEEDED);
		runPane.add(runsp);
		runPane.add(bRun);
		gc.gridx=0;
		gc.gridy=3;
		gb.setConstraints(runPane,gc);
		pane.add(runPane);
		
		gc.gridx=0;
		gc.gridy=4;
		gb.setConstraints(output,gc);
		pane.add(output);
		output.setEnabled(false);
		output.addActionListener(this);
		output.setActionCommand("output");
		
		win=new JWindow();
	}
	public void actionPerformed(ActionEvent ae)
	{
		String btn=ae.getActionCommand();
		
		if(btn.equals("ok"))
		{
			for(int i=0;i<flags.length;i++)
			{
				if(checkboxes[i].isSelected())
				{
					command=command+flags[i]+" "+textboxes[i].getText()+" ";
				}
			}
			tbRun.setText(command);
			command="g_rms ";
		}
		if(btn.equals("run"))
		{
			command=tbRun.getText();
			if(command.trim().indexOf("g_rms -h")!=-1)
			{
				JOptionPane.showMessageDialog(null,"You have chosen the -h flag with the command.\nPlease use GUIMACS Command Help menu instead.","Help",JOptionPane.INFORMATION_MESSAGE);
			}
			if(!command.trim().equals("g_rms"))
			{
				
				Thread runner=new Thread()
				{
					public void run()
					{
						try{
							BufferedWriter bw=new BufferedWriter(new FileWriter("/tmp/grms.exp"));
							bw.write("#!/bin/expect\n");
							bw.write("spawn "+command+"\n");
							bw.write("set timeout 5\n");
							bw.write("expect EOF");
							bw.close();
							String[] runcomm={"/bin/sh","-c","expect /tmp/grms.exp >/tmp/grms"};
							Process proc=Runtime.getRuntime().exec(runcomm);
							win.setSize(300,50);
							win.setLocation(100,100);
							JPanel pan = new JPanel();
							Font f=new Font("serif",Font.BOLD,24);
							pan.setBorder(BorderFactory.createLineBorder(Color.blue));
							win.getContentPane().add(pan,BorderLayout.CENTER);
							pan.setLayout(new FlowLayout());
							pan.setFont(f);
							JLabel l=new JLabel("Please Wait...");
							l.setFont(f);
							pan.add(l);
							pan.setBackground(Color.WHITE);
							win.setVisible(true);
							int rv=proc.waitFor();
							win.setVisible(false);
						}
						catch(IOException ioe)
						{
							JOptionPane.showMessageDialog(null,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
						}
						catch(InterruptedException inte)
						{
							JOptionPane.showMessageDialog(null,inte,"Interrupted Exception",JOptionPane.ERROR_MESSAGE);
						}
						try{
							BufferedReader ct=new BufferedReader(new FileReader("/tmp/grms"));
							while((nextline=ct.readLine())!=null)
							{
								if(nextline.indexOf("Group")==0)
								{
									cnt++;
								}
							}
							ct.close();
							BufferedReader br=new BufferedReader(new FileReader("/tmp/grms"));
							groups=new String[cnt];
							while((nextline=br.readLine())!=null)
							{
								if(nextline.indexOf("Group")==0)
								{
									groups[ndx]=nextline;
									ndx++;
								}
							}
							br.close();
						}
						catch(FileNotFoundException fnfe)
						{
							JOptionPane.showMessageDialog(null,fnfe,"File Not Found Exception",JOptionPane.ERROR_MESSAGE);
						}
						catch(IOException ioe)
						{
							JOptionPane.showMessageDialog(null,ioe,"IOException",JOptionPane.ERROR_MESSAGE);
						}
						if(groups.length!=0)
						{
							gs=new GroupSelector(groups,groups,command,pwd);
							gs.show();
						}
						else
						{
							JOptionPane.showMessageDialog(null,"There was a fatal error while trying to run g_rms.\nPlease try again.","Error",JOptionPane.ERROR_MESSAGE);
						}
						cnt=0;
						ndx=0;
					}
				};
				runner.start();
				output.setEnabled(true);
			}
			else
			{
				if(command.trim().indexOf("g_rms -h")==-1)
				{
					JOptionPane.showMessageDialog(null,"Invalid Run String. Please choose proper input files to proceed.","Input Error",JOptionPane.ERROR_MESSAGE);
				}
			}
		}
		if(btn.equals("output"))
		{
			opf=new JFrame("Options");
			opf.setVisible(true);
			opf.setResizable(false);
			opf.setLocationRelativeTo(null);
			Box box=Box.createVerticalBox();
			opf.getContentPane().add(box);
			box.add(Box.createRigidArea(new Dimension(0,20)));
			JPanel pView=new JPanel(new GridLayout(3,3));
			bLog=new JButton("View Output Log File");
			bClg=new JButton("Clean up Log Files");
			bCbk=new JButton("Remove backed up files");
			bOut=new JButton("Close This Window");
			bLog.addActionListener(this);
			bLog.setActionCommand("log");
			bClg.addActionListener(this);
			bClg.setActionCommand("clog");
			bCbk.addActionListener(this);
			bCbk.setActionCommand("cbk");
			bOut.addActionListener(this);
			bOut.setActionCommand("out");
			pView.add(bLog);
			if(!(new File(pwd+"/command.log")).exists())
			{
				bLog.setEnabled(false);
			}
			pView.add(bClg);
			if(!(new File(pwd+"/command.log")).exists())
			{
				bClg.setEnabled(false);
			}
			pView.add(bCbk);
			pView.add(bOut);
			box.add(pView);
			box.add(Box.createRigidArea(new Dimension(0,20)));
			opf.setLocationRelativeTo(null);
			opf.pack();
		}
		if(btn.equals("log"))
		{
			String filename=pwd+"/command.log";
			out=new output(filename);
			out.show();
		}
		if(btn.equals("clog"))
		{
			(new File(pwd+"/command.log")).delete();
			JOptionPane.showMessageDialog(null,"Operation Successful");
			bClg.setEnabled(false);
			bLog.setEnabled(false);
		}
		if(btn.equals("cbk"))
		{
			try{
				String[] runcomm={"/bin/sh","-c","rm -f "+pwd+"/\\#*"};
				Process proc=Runtime.getRuntime().exec(runcomm);
				proc.waitFor();
				JOptionPane.showMessageDialog(null,"Cleaned up back up files");
				bCbk.setEnabled(false);
			}
			catch(IOException ioe)
			{
				JOptionPane.showMessageDialog(null,ioe);
			}
			catch(InterruptedException inte)
			{
				JOptionPane.showMessageDialog(null,inte);
			}
		}
		if(btn.equals("out"))
		{
			opf.hide();
		}
		for(int i=0;i<flags.length;i++)
		{
			if(btn.equals(flags[i]))
			{
				int retval=jfc.showOpenDialog(null);
				String fname="";
				if(retval==JFileChooser.APPROVE_OPTION)
				{
					File myFile=jfc.getSelectedFile();
					fname=myFile.toString();
					textboxes[i].setText(fname);
				}
			}
		}
	
	}
}
